%Modulacja SSB - dolna wstga
%Autor: Pawe Jarosz

SAMPLE=4400;
Nosna=1000;

%sygnal np. Sinus
%Czas od 0 do 1 z SAMPLE ilosci prbek
t = (0:1/SAMPLE:5)';
x = sin(2*pi*t);	% np. jeden okres sinusoidy

% x = sawtooth(2*pi*t,.5); % Trjkt
% x = square(2*pi*t); %Prostokt
% x = 0.3*sin(2*pi*t)+0.5*sin(3*pi*t)+0.2*sin(4*pi*t);	% Jaki sygna

%Warto pomocnicza, dziaa troch szybciej, do uzyskania czstotliwoci modulujcej
v=2*pi*Nosna;

%  sin(2*pi*Fc*t)*sin(2*pi*Fs*t)+cos(2*pi*Fc*t)*cos(2*pi*Fs*t)=cos(2*pi*t(Fs-Fc))
%                                                              ------------------ 
% Do przesunicia sygnau w fazie wykorzystuje si transformator Hilberta

%Warto pomocnicza, dziaa troch szybciej, do uzyskania czstotliwoci modulujcej
v=2*pi*Nosna;

%Zasadnicza modulacja sygna wejciowy * nona = A(t)*sin(2*pi*Fm*t)
y=x.*sin(v*t)-imag(hilbert(x)).*cos(v*t); %- we wzorze -> przes. -pi/2 ma by pi/2



[b,a]=cheby2(5,1,[0.37 0.44]); %Mona zmniejszy pasmo 
y=filter(b,a,y); %Filtr rodkowo - przepustowy
%Poka rezultat -> sygna po modulacji (niebieski) i oryginalny (czerwony)
plot(t,y,'b-',t,x,'r-') , title('Modulacja SSB - dolna wstga')
pause;
%pokaz FFT
Q=fft(y,256);

%Modu
Pyy = Q.*conj(Q)/127;
f=(SAMPLE/512)*(0:127);

plot(f,Pyy(1:128)) , title('Analiza widma')

pause;

%
%Demodulacja SSB
Pasmo=100;
yd=y;
yd = yd.*sin(2*pi*Nosna*t+pi/4);
%FFT po wymnoeniu -> odzysk sygnau pierwotnego
Q=fft(yd,256);
%Modu
Pyy = Q.*conj(Q)/127;
f=(SAMPLE/512)*(0:127);
plot(f,Pyy(1:128)) , title('Analiza widma po *sin')
pause;
% i Jeszcze tylko filtr dolnoprzepustowy
norm=2*Pasmo/SAMPLE; %Normalizacja do 1 - poowa czstotliwoci prbkowania
[b,a]=butter(5,norm);
o=filter(b,a,yd);

%I poka wynik
plot(t,o,'b-',t,x,'g--'), title('Sygna po demodulacji (niebieski) v sygna przed modulacj (zielony)')

sprintf('Koniec dema demodulacji SSB - Nacinij dowolny klawisz')
pause;
