%sumulacja odwrotny DTMF
%do wyboru generacja zaszumionego sygnau lub korzystanie z sampli
%dostpnych w matlab'ie
%
% Rafa Piskunowicz
% Rafa Posuszny
%
% DSP-L 1999
%
close;
load ptones
% wybor sampli z pliku lub ich generacja 
% nalezy zakomentowac niewybrany blok

% wybr z pliku
 t=tones1(:,14);
 amp=tones1(:,5); % prosze tutaj wybrac numer lub zakomentowc dla
		   % generacji sygnau

% generacja
 t=tones1(:,14);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%        % 1209 % 1336 % 1477 %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 697 Hz %   1  %   2  %   3  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 770 Hz %   4  %   5  %   6  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 852 Hz %   7  %   8  %   9  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 941 Hz %   *  %   0  %   #  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 %amp1=sin(2*pi*852*t)+sin(2*pi*1477*t); % prosz zakomentowa
 %amp = amp1 + 2*randn(size(t));         % dla SYGNAU z pliku

% wyswietlenie probek wejsciowych
 plot(t,amp);
 xlabel('czas [s]');ylabel('amplituda');
 title('Sygnal wejsciowy');
 pause;

% liczenie i wyswietlenie FFT
 Y=[];Pyy=[];
 Y = fft(amp,128);
 Pyy = Y.*conj(Y)/128;
 f = 8192/128*(0:63);
 semilogy(f,Pyy(1:64));
 xlabel('czestotliwosc [Hz]');ylabel('amplituda');
 title('Widmo sygnalu wejsciowego');
 pause;

% filtrowanie 
 [b,a]=yulewalk(25,[0 0.155 0.16 0.165 0.17 0.175 0.18 0.185 0.19 0.195 0.20  0.205 0.21 0.215 0.22 0.225 0.23 0.235 0.24 0.29 0.295 0.30 0.305 0.32 0.325 0.33 0.335 0.355 0.36 0.365 0.37 0.395 0.40 0.41 1],[0 0 0.1 1     1    1     0    1     1    1     0     1     1    1     0    1     1     1    0    1    1     1    0     1    1     1    0     1     1    1     0    1     1    1    0])
 POF=filter(b,a,amp);																							
 b=fir1(30,[0.001,0.14],'stop')  
 a=1;
 POF2=filter(b,a,amp);
 POF=POF2;
 b=fir1(30,[0.41,0.999],'stop')  
 a=1;
 POF2=filter(b,a,amp);
 POF=POF2;

 %POF=amp; % odkomentowac aby pomin filtracje
% liczenie i wyswietlenie FFT dla sygnalu przefiltrowanego
 Y=[];Pyy=[];
 Y = fft(POF,128);
 Pyy = Y.*conj(Y)/128;
 f = 8192/128*(0:63);
 semilogy(f,Pyy(1:64)*1.5);
 xlabel('czestotliwosc [Hz]');ylabel('amplituda');
 title('Widmo sygnalu wejsciowego po filtracji');
 pause;

% liczenie maksimum
 DTMFX=[ 697 770 852 941 1209 1336 1477];
 DTMFY=[];
 DTMFY1=[];
 DTMFY2=[];

 x=[Pyy(11) Pyy(12)]
 y=find(x==max(x));
 DTMFY(1)=x(y);
 DTMFY1(1)=x(y);
 DTMFY(2)=Pyy(13);
 DTMFY1(2)=Pyy(13); 
 x=[Pyy(14) Pyy(15)]
 y=find(x==max(x));
 DTMFY(3)=x(y);
 DTMFY1(3)=x(y);
 DTMFY(4)=Pyy(16);
 DTMFY1(4)=Pyy(16); 
 

 DTMFY(5)=Pyy(20);
 DTMFY2(1)=Pyy(20); 
 x=[Pyy(22) Pyy(23)];
 y=find(x==max(x));
 DTMFY(6)=x(y);
 DTMFY2(2)=x(y);
 x=[Pyy(24) Pyy(25)];
 y=find(x==max(x));
 DTMFY(7)=x(y);
 DTMFY2(3)=x(y);
% wyswietlenie maksymalnych wartosci
 semilogy(DTMFX,DTMFY,'+');
 xlabel('czestotliwosc [Hz]');ylabel('amplituda');
 title('Wartosci przy czestotliwosciach DTMF');
 pause;

% dekodowanie na nacisniety klawisz telefonu
 index1=find(DTMFY1==max(DTMFY1));
 index2=find(DTMFY2==max(DTMFY2));

 if (index1==1)
   if( index2==1) 
	disp('NACISNIETO 1')
   end
   if( index2==2) 
	disp('NACISNIETO 2')
   end
   if( index2==3) 
	disp('NACISNIETO 3')
   end
 end;
 if (index1==2)
   if( index2==1) 
	disp('NACISNIETO 4')
   end
   if( index2==2) 
	disp('NACISNIETO 5')
   end
   if( index2==3) 
	disp('NACISNIETO 6')
   end
 end;
 if (index1==3)
   if( index2==1) 
	disp('NACISNIETO 7')
   end
   if( index2==2) 
	disp('NACISNIETO 8')
   end
   if( index2==3) 
	disp('NACISNIETO 9')
   end
 end;
 if (index1==4)
   if( index2==1) 
	disp('NACISNIETO *')
   end
   if( index2==2) 
	disp('NACISNIETO 0')
   end
   if( index2==3) 
	disp('NACISNIETO #1')
   end
 end;


