function dtmf(action)

%     Rozpoznawanie sygnalow wybierania tonowego
%
%              LABORATORIUM DSP
%       Andrzej Pyzik & Marcin Wojtkiewicz
%                Wroclaw 1999


global tones1 tones2 pad wn

if nargin<1,
    action='initialize';
end;

if strcmp(action,'initialize'),
    figNumber=figure( ...
        'Name','DTMF', ...
        'NumberTitle','off', ...
        'Backingstore','off', ...
        'Visible','off');

   axHndl1=axes( ...
        'Units','normalized', ...
        'Position',[0.10 0.60 0.60 0.32], ...
	'Drawmode','fast', ...
	'Visible','on');
    axHndl2=axes( ...
        'Units','normalized', ...
        'Position',[0.10 0.10 0.60 0.32], ...
	'Drawmode','fast', ...
	'Visible','on'); 

    %===================================
    % Dane dla elementow okna
    labelColor=[0.8 0.8 0.8];
    top=0.85;
    left=0.75;
    bottom=0.05;
    xLabelPos=0.75;
    labelWid=0.20;
    labelHt=0.05;
    btnWid=0.20;
    btnHt=0.08;
    editHt=0.04;
    editWid=0.04;
    textHt=0.04;
    textWid=0.2;
    spacing=0.05;
    btnOffset=0.;
    
    %====================================
    % Ramka konsoli
    % Zaladowanie probek dzwieku wybierania tonowego z  MAT-file TONES
    load ptones
    frmBorder=0.02;
    yPos=bottom-frmBorder;
    frmPos=[left-frmBorder yPos btnWid+2*frmBorder 0.9+2*frmBorder];
    frmHndl=uicontrol( ...
        'Style','frame', ...
        'Units','normalized', ...
        'Position',frmPos, ...
        'BackgroundColor',[0.50 0.50 0.50]);

    %====================================
    % Przyciski telefonu
    %btnNumber=1;
    %yLabelPos=0.90-(btnNumber-1)*(btnHt+labelHt+spacing);
    labelStr=' Button No.';
    
    for count=1:12,
        btnPos=[xLabelPos+rem(count-1,3)*(btnWid/3) ...
            (top-floor((count-1)/3)*(btnWid/3))+0.03 btnWid/3 btnWid/3];
        btnStr=num2str(count);
        if count==10, btnStr='*'; end;
        if count==11, btnStr='0'; end;
        if count==12, btnStr='#'; end;
        uicontrol( ...
            'Style','pushbutton', ...
            'Units','normalized', ...
            'Position',btnPos, ...
            'String',btnStr, ...
            'UserData',count, ...
            'Callback','dtmf(''tone'')');
    end;

    %====================================
    % Checkbox dla odtwarzania tonu
    btnNumber=2;
    yPos=top-3*btnHt;
    labelStr='Dzwiek';
    btnPos=[left (yPos-btnHt)+btnHt btnWid btnHt/2];
    sndHndl=uicontrol( ...
        'Style','checkbox', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'Enable','on', ...
        'String',labelStr);

    %====================================
    % Przycisk INFO
    labelStr='Info';
    callbackStr='dtmf(''info'')';
    infoHndl=uicontrol( ...
        'Style','push', ...
        'Units','normalized', ...
        'Position',[left bottom+btnHt+spacing btnWid btnHt], ...
        'String',labelStr, ...
        'Callback',callbackStr);

    %====================================
    % Przycisk ZAMKNIJ
    labelStr='Zamknij';
    callbackStr='close(gcf)';
    closeHndl=uicontrol( ...
        'Style','push', ...
        'Units','normalized', ...
        'Position',[left bottom btnWid btnHt], ...
        'String',labelStr, ...
        'Callback',callbackStr);
    %====================================
    % Przycisk "<" 
    labelStr='<';
    leftHndl=uicontrol( ...
        'Style','push', ...
        'Units','normalized', ...
        'Position',[left bottom+5.5*btnHt btnWid/4 btnHt/2], ...
        'String',labelStr, ...
        'Callback','dtmf(''left'')');
    %====================================
    % Przycisk ">" 
    labelStr='>';
    rightHndl=uicontrol( ...
        'Style','push', ...
        'Units','normalized', ...
        'Position',[left+3*(btnWid/4) bottom+5.5*btnHt btnWid/4 btnHt/2], ...
        'String',labelStr, ...
        'Callback','dtmf(''right'')');
    %====================================
    % Pole tekstowe
    labelPos=[left bottom+6*btnHt textWid textHt];
    textHndl = uicontrol( ...
        'Style','text', ...
        'Units','normalized', ...
        'Position', labelPos, ...
        'String','Start okna');
    %====================================
    % Pole edycyjne do wyboru polozenia okna
     editHndl = uicontrol( ...
        'Style','edit', ...
        'Units','normalized', ...
        'Position',[0.83 bottom+5.5*btnHt editWid editHt], ...
        'BackgroundColor','w',...
        'String',' 1',...
        'Callback','dtmf(''edit'')');
 
    %====================================
    % Pola tekstowe pokazujace wynik 
    labelPos=[left bottom+4*btnHt 0.15 textHt];
    wyniktextHndl = uicontrol( ...
        'Style','text', ...
        'Units','normalized', ...
        'BackgroundColor','y',...
        'HorizontalAlignment','left',...
        'Position', labelPos, ...
        'String','  Wynik : ');

    labelPos=[left+0.12 bottom+4*btnHt 0.08 textHt];
    wynikHndl = uicontrol( ...
        'Style','text', ...
        'Units','normalized', ...
        'BackgroundColor','y',...
        'HorizontalAlignment','left',...
        'Position', labelPos, ...
        'String','   ');

    pad(9,15)='1';
    pad(9,16)='2';
    pad(9,18)='3';
    pad(10,15)='4';
    pad(10,16)='5';
    pad(10,18)='6';             % Tablica znakow klawiatury
    pad(11,15)='7';
    pad(11,16)='8';
    pad(11,18)='9';
    pad(12,15)='*';
    pad(12,16)='0';
    pad(12,18)='#';
    wn=90;                      % 'wn' Dlugosc okna 

    % Iniicjalizacja wykresu dla tonu "1"
    Fs=8192;    
    
    axes(axHndl2);
    toneokno=tones1(1:wn,1);
    plot2Hndl=plot(toneokno,'Erasemode','background');
    xlabel('Time (sec)');
    ylabel('Signal');
    title('Time Response');
       
    axes(axHndl1);
    tone=tones1(:,1);
    plot1Hndl=plot(abs(fft(tone,wn)),'Erasemode','background');
    %xlabel('n');
    %ylabel('y(n)');
    title('WIDMO');
    %set(axHndl1,'XLim',[0 0.05],'YLim',[-1 1]);
    
    set(figNumber,'Visible','on', ...
        'UserData',[frmHndl infoHndl closeHndl plot1Hndl plot2Hndl sndHndl editHndl wynikHndl]);

elseif strcmp(action,'tone'),
    figNumber=watchon;
    hndlList=get(figNumber,'Userdata');
    frmHndl=hndlList(1);
    infoHndl=hndlList(2);
    closeHndl=hndlList(3);
    plot1Hndl=hndlList(4);
    plot2Hndl=hndlList(5);
    sndHndl=hndlList(6);
    editHndl=hndlList(7);
    wynikHndl=hndlList(8);
  
    % ====== Wykrywanie i odtwarzanie tonu
    % Czestotliwosc probkowania wynosi : 8192 Hz
    Fs = 8192;    
    toneChoice=get(gco,'UserData');
    
    poz= str2num(get(editHndl,'string'));
    tone=tones1(poz:400,toneChoice);
    toneokno=tones1(poz:poz+wn-1,toneChoice);
    %tone=tone+0.1*randn(1,length(tone));
    
    set(plot2Hndl,'YData',toneokno);


    tab=abs(fft(tone,wn));
    set(plot1Hndl,'YData',tab);

    if get(sndHndl,'Value'),
        sound([tones1(:,toneChoice); tones2(:,toneChoice)],Fs);
    end
    
    i=2;
    j=1;
    max(16)=0; 
    x_max(16)=0;
    while (i<32)        
	if ( (tab(i)>tab(i-1)) & (tab(i)>tab(i+1)) )  %Petla wyszukujaca maksima lokalne
	   max(j)=tab(i);   
           x_max(j)=i;
           j=j+1;
        end
        i=i+1;
    end
    i=1;
    f1=0;
    f2=0;
    while(i<17)
	if (max(i)>f1)
	   f1=max(i);        %Petla wyszukujaca  maksimum globalne
           zero=i;
	end
     i=i+1;
    end
    f1=x_max(zero);
    max(zero)=0;
    i=1;
    while(i<17)
	if (max(i)>f2)       %Petla wyszukujaca najwieksze maksimum lokalne
	   f2=max(i);
           zero=i;
	end
     i=i+1;
    end
    f2=x_max(zero);
    if (f1>14)
      set(wynikHndl,'string',pad(f2,f1));    
    else                                     %Pobranie odpowiedniego kodu wykrytego tonu
      set(wynikHndl,'string',pad(f1,f2));
    end

    watchoff(figNumber);

elseif strcmp(action,'colormap'),
    hndl=gco;
  

elseif strcmp(action,'mode'),
    hndl=gco;

elseif strcmp(action,'edit'),
     figNumber=watchon;
    hndlList=get(figNumber,'Userdata');
    frmHndl=hndlList(1);
    infoHndl=hndlList(2);
    closeHndl=hndlList(3);
    plot1Hndl=hndlList(4);
    plot2Hndl=hndlList(5);
    sndHndl=hndlList(6);
    editHndl=hndlList(7);
    wynikHndl=hndlList(8);

    pom=str2num(get(editHndl,'string'));
    if (pom>310)
      set(editHndl,'string','310');         %Ograniczenia punktu startowego okna
    elseif (pom<1)        
      set(editHndl,'string','1');
    end 
    watchoff(figNumber);
elseif strcmp(action,'left'),
    figNumber=watchon;
     hndlList=get(figNumber,'Userdata');
    frmHndl=hndlList(1);
    infoHndl=hndlList(2);
    closeHndl=hndlList(3);
    plot1Hndl=hndlList(4);
    plot2Hndl=hndlList(5);
    sndHndl=hndlList(6);
    editHndl=hndlList(7);
    wynikHndl=hndlList(8);

    pom= str2num(get(editHndl,'string'));
    if (pom>1) 
    set(editHndl,'string',pom-1);     	    %Sterowanie punktem startowym okna	
    end
    watchoff(figNumber);     
    
elseif strcmp(action,'right'),
    figNumber=watchon;
     hndlList=get(figNumber,'Userdata');
    frmHndl=hndlList(1);
    infoHndl=hndlList(2);
    closeHndl=hndlList(3);
    plot1Hndl=hndlList(4);
    plot2Hndl=hndlList(5);
    sndHndl=hndlList(6);
    editHndl=hndlList(7);
    wynikHndl=hndlList(8);
    
    pom= str2num(get(editHndl,'string'));
    if (pom<310)			     %Sterowanie punktem startowym okna	
     set(editHndl,'string',pom+1);     
    end

    watchoff(figNumber);     
elseif strcmp(action,'info'),
    ttlStr=get(gcf,'Name');
    hlpStr= ...                                          
       [ ' Program ten rozpoznaje tony wybierania     '  
         ' tonowego badajac skladowe czestotliwosci.  '
         ' Sygnal jest podawany na wejscie funkcji    ' 
         ' FFT, ktora realizuje transformate Fouriera.' 
         ' Wykres przedstawia wartosc bezwzgledna z   '  
         ' wyniku dzialania funkcji FFT. Na tym       '
         ' sygnale przeprowadzamy rozpoznawanie tonu. '               
         ' Dlugosc okna 90                            '  
         '                                  (C) AP&MW ' 
         ' Nazwa pliku: dtmf.m                        ']; 
    helpfun(ttlStr,hlpStr);                              

end;