unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, StdCtrls, MMSystem;

const
  SAMPLE_CNT = 60000; //liczba probek w buforze
  SIG_BUF_SIZE = SAMPLE_CNT * SizeOf(SmallInt); //rozmiar bufora sygnalowego
  SIG_BUF8_SIZE = SAMPLE_CNT * SizeOf(Byte); //rozmiar bufora sygnalowego (8 bit)

type
  TSignalBuf = array[0..SAMPLE_CNT-1] of SmallInt;
  PSignalBuf = ^TSignalBuf;
  TSignalBuf8 = array[0..SAMPLE_CNT-1] of Byte;
  PSignalBuf8 = ^TSignalBuf8;

{watek obslugujacy ciagla generacje sygnalu}
  TSignalThread = class(TThread)
  private
    hCloseEvent: THandle;
    hBufDoneEvent: THandle;
    hChgParamEvent: THandle;
    hChgModeEvent: THandle;
  protected
    procedure Execute; override;
  public
    constructor Create;
    destructor Destroy; override;
    procedure ChangeParam;
    procedure ChangeMode;
    procedure ReleaseThread;
  end;

  TForm1 = class(TForm)
    RadioGroup1: TRadioGroup;
    GroupBox1: TGroupBox;
    UpDown1: TUpDown;
    Edit1: TEdit;
    TrackBar1: TTrackBar;
    GroupBox2: TGroupBox;
    Edit2: TEdit;
    UpDown2: TUpDown;
    TrackBar2: TTrackBar;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Bevel1: TBevel;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Image1: TImage;
    Label5: TLabel;
    RadioGroup2: TRadioGroup;
    GroupBox3: TGroupBox;
    ComboBox1: TComboBox;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure UpDown2Click(Sender: TObject; Button: TUDBtnType);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
  private
    { Private declarations }
    Lock:Boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

  DevHandle:HWAVEOUT; //uchwyt urzadzenia odtwarzajacego
  SignalThread:TSignalThread; //watek generujacy i odtwarzajacy

  Fp:Integer; //czestotliwosc probkowania
  Bit16:Boolean; //0 = 8, 1 = 16 bit/smp

  Freq, OldFreq:Integer;
  Amp:Integer;
  Gen:Boolean;
  Info:Boolean;
  BufPtrs:array[0..2] of Pointer;  //wskazniki buforow sygnalowych
  BufHdrs:array[0..2] of TWaveHdr; //naglowki buforow sygnalowych
  BufToWrite:Integer;  //indeks wolnego bufora oczekujacego na nowe dane

  AmpX:SmallInt;
  K:Integer;
  F,M,TS:Integer;
  A,N,D,T,T2,OX:Double;
  Pipe:array[0..2] of Double;

  function  InitWaveDev(EventHandle:THandle):Boolean;
  function  PrepBufHdr(BufIndex:Integer):boolean;
  function  PrepBuf8Hdr(BufIndex:Integer):boolean;
  function  UnPrepBufHdr(BufIndex:Integer):boolean;
  procedure InitSinus;
  procedure InitTriangle;
  procedure InitRectangle;
  procedure InitNoise;
  function  GetSinus:SmallInt;
  function  GetTriangle:SmallInt;
  function  GetRectangle:SmallInt;
  function  GetNoise:SmallInt;
  procedure InitGenerator;
  procedure GenerateSignal(BufIndex:Integer);


implementation

{$R *.DFM}


//---------------procedury generacji sygnalu -----------
procedure InitSinus;
var C:Double;
begin
  A:=2*cos(2*Pi/N);
  C:=sin(2*Pi/N);
  Pipe[0]:=0;
  Pipe[1]:=-C;
  Pipe[2]:=0;
end;

procedure InitTriangle;
begin
  D:=4/N;
  T:=0;
  T2:=0;
  TS:=1; //narastanie = 1, opadanie = -1
end;

procedure InitRectangle;
begin
  M:=round(N/2);
  OX:=0;
end;

procedure InitNoise;
begin
  Randomize;
end;

function  GetSinus:SmallInt;
begin
  Pipe[2]:=Pipe[1];
  Pipe[1]:=Pipe[0];
  Pipe[0]:=A*Pipe[1]-Pipe[2];
  Result:=Round(Pipe[0]*AmpX);
end;

function  GetTriangle:SmallInt;
begin
{  T:=T2;
  T:=T+(TS*D);
  T2:=T;
  if T>1 then begin
    T:=1;
    T2:=1-(T2-T); //T2:=2-T2
    TS:=-1;
  end;
  if T<-1 then begin
    T:=-1;
    T2:=-1+(T-T2); //T2:=-2-T2
    TS:=1;
  end;}

  T:=T+(TS*D);
  if T>1 then begin
    T:=2-T;
    TS:=-1;
  end;
  if T<-1 then begin
    T:=-2-T;
    TS:=1;
  end;
  Result:=Round(T*AmpX);
end;

function  GetRectangle:SmallInt;
var R:SmallInt;
begin
  if OX < M then R:=1 else R:=-1;
  OX:=OX + 1;
  if OX >= N then OX:=OX - N;
  Result:=R*AmpX;
end;

function  GetNoise:SmallInt;
begin
  Result:=SmallInt(Random(2*AmpX+1)-AmpX);
end;

procedure InitGenerator;
begin
  case K of
    0:InitSinus;
    1:InitTriangle;
    2:InitRectangle;
    3:InitNoise;
  end;
end;

procedure GenerateSignal(BufIndex:Integer);
var i,j:Integer;
begin
  case Bit16 of
    True: AmpX:=(32767*Amp) div 100;
    False: AmpX:=(127*Amp) div 100;
  end;
  if OldFreq<>Freq then begin
    N:=Fp/Freq;
    OldFreq:=Freq;
    InitGenerator;
  end;
  if Bit16 then begin
    case K of
      0:begin
          for i:=0 to SAMPLE_CNT - 1 do
            PSignalBuf(BufPtrs[BufIndex])^[i]:=GetSinus;
        end;
      1:begin
          for i:=0 to SAMPLE_CNT - 1 do
            PSignalBuf(BufPtrs[BufIndex])^[i]:=GetTriangle;
        end;
      2:begin
          for i:=0 to SAMPLE_CNT - 1 do
            PSignalBuf(BufPtrs[BufIndex])^[i]:=GetRectangle;
        end;
      3:begin
//        Randomize;
          for i:=0 to SAMPLE_CNT - 1 do
            PSignalBuf(BufPtrs[BufIndex])^[i]:=GetNoise;
        end;
    end;
  end
  else begin
    case K of
      0:begin
          for i:=0 to SAMPLE_CNT - 1 do
            PSignalBuf8(BufPtrs[BufIndex])^[i]:=GetSinus+128;
        end;
      1:begin
          for i:=0 to SAMPLE_CNT - 1 do
            PSignalBuf8(BufPtrs[BufIndex])^[i]:=GetTriangle+128;
        end;
      2:begin
          for i:=0 to SAMPLE_CNT - 1 do
            PSignalBuf8(BufPtrs[BufIndex])^[i]:=GetRectangle+128;
        end;
      3:begin
          for i:=0 to SAMPLE_CNT - 1 do
            PSignalBuf8(BufPtrs[BufIndex])^[i]:=GetNoise+128;
        end;
    end;
  end;
end;


//------ procedury pomocnicze dla obslugi WAVEOUT ------

function InitWaveDev(EventHandle:THandle):Boolean;
var FormatDescr:TWaveFormatEx;
    Res:MMResult;
    dwHandleSignaled: DWORD;
    ErrTxt:array[0..255] of char;
begin
  DevHandle:=0;
  Result:=True;
  FormatDescr.wFormatTag:=1; //PCM
  FormatDescr.nChannels:=1;  //mono
  FormatDescr.nSamplesPerSec:=Fp;  //44100;
  if Bit16 then begin
    FormatDescr.nAvgBytesPerSec:=Fp*2; //88200;
    FormatDescr.nBlockAlign:=2;
    FormatDescr.wBitsPerSample:=16; //16-bit
  end
  else begin
    FormatDescr.nAvgBytesPerSec:=Fp; //44100;
    FormatDescr.nBlockAlign:=1;
    FormatDescr.wBitsPerSample:=8; //8-bit
  end;
  FormatDescr.cbSize:=0;
  Res:=WaveOutOpen(@DevHandle, WAVE_MAPPER, @FormatDescr, EventHandle, 0, CALLBACK_EVENT);
  if Res<>MMSYSERR_NOERROR then begin
    waveOutGetErrorText(Res,ErrTxt,SizeOf(ErrTxt));
    Application.MessageBox(PChar('Bd urzdzenia WAVEOUT: '
    +IntToStr(Res)+#13#10+string(ErrTxt)),'Generator',MB_OK+MB_ICONERROR);
    Result:=False;
  end
  else begin
//    repeat
{otworzenie WAVEOUT tez generuje zdarzenie wiec trzeba je sksowac}
      dwHandleSignaled:=WaitForSingleObject(EventHandle,INFINITE);
//    until dwHandleSignaled=WAIT_OBJECT_0;
  end;
end;

function PrepBufHdr(BufIndex:Integer):boolean;
var Res:MMResult;
begin
  ZeroMemory(@BufHdrs[BufIndex],SizeOf(TWaveHdr));
  BufHdrs[BufIndex].lpData:=BufPtrs[BufIndex];
  BufHdrs[BufIndex].dwBufferLength:=SIG_BUF_SIZE;
  Res:=WaveOutPrepareHeader(DevHandle,@(BufHdrs[BufIndex]),SizeOf(TWaveHdr));
  if Res<>MMSYSERR_NOERROR then Result:=False
  else Result:=True;
end;

function PrepBuf8Hdr(BufIndex:Integer):boolean;
var Res:MMResult;
begin
  ZeroMemory(@BufHdrs[BufIndex],SizeOf(TWaveHdr));
  BufHdrs[BufIndex].lpData:=BufPtrs[BufIndex];
  BufHdrs[BufIndex].dwBufferLength:=SIG_BUF8_SIZE;
  Res:=WaveOutPrepareHeader(DevHandle,@(BufHdrs[BufIndex]),SizeOf(TWaveHdr));
  if Res<>MMSYSERR_NOERROR then Result:=False
  else Result:=True;
end;

function UnPrepBufHdr(BufIndex:Integer):boolean;
var Res:MMResult;
begin
  Res:=WaveOutUnprepareHeader(DevHandle,@(BufHdrs[BufIndex]),SizeOf(TWaveHdr));
  if Res<>MMSYSERR_NOERROR then Result:=False
  else Result:=True;
end;


//---------------------TSignalThread--------------------
//---- metody watku obslugujacego generacje sygnalu ----

constructor TSignalThread.Create;
begin
  Inherited Create(true);
//  Priority := tpHighest;
  Priority := tpTimeCritical;
  Resume;
end;

destructor TSignalThread.Destroy;
begin
  CloseHandle(hCloseEvent);
  CloseHandle(hBufDoneEvent);
  CloseHandle(hChgParamEvent);
  Inherited Destroy;
end;

procedure TSignalThread.Execute;
var
  HandlesToWaitFor: array[0..3] of THandle;
  dwHandleSignaled: DWORD;
  Buf1,Buf2:Integer;
begin
  hCloseEvent := CreateEvent(nil, True, False, nil);
  hBufDoneEvent := CreateEvent(nil, False, False, nil);
  hChgParamEvent := CreateEvent(nil, False, False, nil);
  hChgModeEvent := CreateEvent(nil, False, False, nil);
  HandlesToWaitFor[0] := hCloseEvent;
  HandlesToWaitFor[1] := hBufDoneEvent;
  HandlesToWaitFor[2] := hChgParamEvent;
  HandlesToWaitFor[3] := hChgModeEvent;
  if InitWaveDev(hBufDoneEvent) then begin
    case Bit16 of
      True:begin
        PrepBufHdr(0);
        PrepBufHdr(1);
        PrepBufHdr(2);
           end;
      False:begin
        PrepBuf8Hdr(0);
        PrepBuf8Hdr(1);
        PrepBuf8Hdr(2);
            end;
    end;
    GenerateSignal(0);
    GenerateSignal(1);
    WaveOutWrite(DevHandle,@BufHdrs[0],SizeOf(TWaveHdr));
    WaveOutWrite(DevHandle,@BufHdrs[1],SizeOf(TWaveHdr));
    BufToWrite:=2;  //indeks bufora pustego oczekujacego na nowe dane
    repeat
      dwHandleSignaled := WaitForMultipleObjects(4, @HandlesToWaitFor, False, INFINITE);
      case dwHandleSignaled of
        WAIT_OBJECT_0    : Break;
        WAIT_OBJECT_0 + 1:
          begin
            GenerateSignal(BufToWrite);
            WaveOutWrite(DevHandle,@BufHdrs[BufToWrite],SizeOf(TWaveHdr));
            Inc(BufToWrite);
            if BufToWrite > 2 then BufToWrite:=0;
          end;
        WAIT_OBJECT_0 + 2:
          begin
            GenerateSignal(BufToWrite);
            Buf1:=BufToWrite;
            Inc(BufToWrite);
            if BufToWrite > 2 then BufToWrite:=0;
            GenerateSignal(BufToWrite);
            Buf2:=BufToWrite;
            Inc(BufToWrite);
            if BufToWrite > 2 then BufToWrite:=0;
            WaveOutReset(DevHandle);
            WaveOutWrite(DevHandle,@BufHdrs[Buf1],SizeOf(TWaveHdr));
            WaveOutWrite(DevHandle,@BufHdrs[Buf2],SizeOf(TWaveHdr));
            if not(Gen) then WaveOutPause(DevHandle);
          end;
        WAIT_OBJECT_0 + 3:
          begin
            WaveOutReset(DevHandle);
            UnPrepBufHdr(0);
            UnPrepBufHdr(1);
            UnPrepBufHdr(2);
            WaveOutClose(DevHandle);
// teraz otworzy WAVEOUT z nowymi parametrami odtwarzania
            if InitWaveDev(hBufDoneEvent) then begin
              case Bit16 of
                True:begin
                  PrepBufHdr(0);
                  PrepBufHdr(1);
                  PrepBufHdr(2);
                     end;
                False:begin
                  PrepBuf8Hdr(0);
                  PrepBuf8Hdr(1);
                  PrepBuf8Hdr(2);
                      end;
              end;
              GenerateSignal(0);
              GenerateSignal(1);
              WaveOutWrite(DevHandle,@BufHdrs[0],SizeOf(TWaveHdr));
              WaveOutWrite(DevHandle,@BufHdrs[1],SizeOf(TWaveHdr));
              BufToWrite:=2;  //indeks bufora pustego oczekujacego na nowe dane
              if not(Gen) then WaveOutPause(DevHandle);
            end;
          end;
        else
          Break;
      end;
    until Terminated;
    WaveOutReset(DevHandle);
    UnPrepBufHdr(0);
    UnPrepBufHdr(1);
    UnPrepBufHdr(2);
    WaveOutClose(DevHandle);
  end;
end;

procedure TSignalThread.ChangeParam;
{informuje watek, ze zmienily sie parametry sygnalu}
begin
  SetEvent(hChgParamEvent);
end;

procedure TSignalThread.ChangeMode;
{informuje watek, ze zmienil sie tryb odtwarzania sygnalu}
begin
  SetEvent(hChgModeEvent);
end;

procedure TSignalThread.ReleaseThread;
begin
  SetEvent(hCloseEvent);
  Terminate;
end;


//---------------- interface uzytkownika --------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  DevHandle:=0;

// ustawienia poczatkowe
  Fp:=44100; //czestotliwosc probkowania
  Bit16:=True; //16 bit/smp

  K:=0;   //ksztalt = sinus
  Freq:=1000;
  OldFreq:=Freq;
  Amp:=50;
  N:=Fp/Freq;
  InitGenerator;

  Gen:=True;
  Info:=False;

  BufPtrs[0]:=nil;
  BufPtrs[1]:=nil;
  BufPtrs[2]:=nil;
  try
    GetMem(BufPtrs[0],SIG_BUF_SIZE);
    GetMem(BufPtrs[1],SIG_BUF_SIZE);
    GetMem(BufPtrs[2],SIG_BUF_SIZE);
  except
    if assigned(BufPtrs[0]) then FreeMem(BufPtrs[0]);
    if assigned(BufPtrs[1]) then FreeMem(BufPtrs[1]);
    if assigned(BufPtrs[2]) then FreeMem(BufPtrs[2]);
    BufPtrs[0]:=nil;
    BufPtrs[1]:=nil;
    BufPtrs[2]:=nil;
  end;
  if (not assigned(BufPtrs[0]))or(not assigned(BufPtrs[1]))
     or(not assigned(BufPtrs[2])) then begin
       Close;
  end;
  ZeroMemory(BufPtrs[0],SIG_BUF_SIZE);
  ZeroMemory(BufPtrs[1],SIG_BUF_SIZE);
  ZeroMemory(BufPtrs[2],SIG_BUF_SIZE);

  SignalThread := TSignalThread.Create;

  Lock:=True;
  RadioGroup1.ItemIndex:=0;
  RadioGroup2.ItemIndex:=1;
  ComboBox1.ItemIndex:=0;
  UpDown1.Position:=Freq;
  UpDown2.Position:=Amp;
  TrackBar1.Position:=Freq div 100;
  TrackBar2.Position:=Amp;
  Edit1.Text:=IntToStr(Freq);
  Edit2.Text:=IntToStr(Amp);
  Lock:=False;

end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SignalThread.ReleaseThread;
  SignalThread.WaitFor;
  SignalThread.Free;
  if assigned(BufPtrs[0]) then FreeMem(BufPtrs[0]);
  if assigned(BufPtrs[1]) then FreeMem(BufPtrs[1]);
  if assigned(BufPtrs[2]) then FreeMem(BufPtrs[2]);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  if Lock then exit;
  Freq:=TrackBar1.Position*100 + (Freq mod 100);
  if (Freq > 22000) then Freq:=22000;
  if (Freq < 1) then Freq:=1;
  UpDown1.Position:=Freq;
  Edit1.Text:=IntToStr(Freq);
  SignalThread.ChangeParam;
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  if Lock then exit;
  Amp:=TrackBar2.Position;
  UpDown2.Position:=Amp;
  Edit2.Text:=IntToStr(Amp);
  SignalThread.ChangeParam;
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  if Lock then exit;
{  case Button of
    btNext:if (Freq < 10000) then inc(Freq);
    btPrev:if (Freq > 0) then dec(Freq);
  end;}
  Freq:=UpDown1.Position;
  TrackBar1.Position:= Freq div 100;
  Edit1.Text:=IntToStr(Freq);
  SignalThread.ChangeParam;
end;

procedure TForm1.UpDown2Click(Sender: TObject; Button: TUDBtnType);
begin
  if Lock then exit;
  Amp:=UpDown2.Position;
  Edit2.Text:=IntToStr(Amp);
  SignalThread.ChangeParam;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  if Lock then exit;
  try
    Freq:=StrToInt(Edit1.Text);
    if (Freq > 22000) then begin
      Freq:=22000;
      Edit1.Text:=IntToStr(Freq);
    end;
    UpDown1.Position:=Freq;
    TrackBar1.Position:= Freq div 100;
    SignalThread.ChangeParam;
  except
  end;
end;

procedure TForm1.Edit2Change(Sender: TObject);
begin
  if Lock then exit;
  try
    Amp:=StrToInt(Edit2.Text);
    if (Amp > 100) then begin
      Amp:=100;
      Edit2.Text:=IntToStr(Amp);
    end;
    UpDown2.Position:=Amp;
    TrackBar2.Position:= Amp;
    SignalThread.ChangeParam;
  except
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
//  if DevHandle = 0 then exit;
  case Gen of
    True:begin
      WaveOutPause(DevHandle);
      Gen:=False;
      Button1.Caption:='Generuj';
    end;
    False:begin
      WaveOutRestart(DevHandle);
      Gen:=True;
      Button1.Caption:='Wstrzymaj';
    end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  case Info of
    True:begin
      Info:=False;
      Height:=248;
      Button3.Caption:='Informacje';
    end;
    False:begin
      Info:=True;
      Height:=362;
      Button3.Caption:='Bez informacji';
    end;
  end;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  if Lock then exit;
  K:=RadioGroup1.ItemIndex;
  InitGenerator;
  SignalThread.ChangeParam;
end;

procedure TForm1.RadioGroup2Click(Sender: TObject);
begin
  if Lock then exit;
  case RadioGroup2.ItemIndex of
    0:Bit16:=False;
    1:Bit16:=True;
  end;
  SignalThread.ChangeMode;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var BFp:Integer;
begin
  if Lock then exit;
  try
    BFp:=StrToInt(ComboBox1.Text);
  except
    BFp:=Fp;
  end;
  Fp:=BFp;
  N:=Fp/Freq;
  InitGenerator;
  SignalThread.ChangeMode;
end;

end.
