b = [0.2,0.187098,0.151365,0.10091,0.046774,-2.047e-17,-0.031183,-0.043247,-0.037841,-0.020789,2.047e-17];
%b - wspolczynniki filtru FIR

d = dir2latc(b) %przeksztalcenie wspolczynnikow FIR na rownowazny mu LATTICE

% LATTICE filter impulse response
close;
n=[-10:200];
x=[(n-0)==0];
y=latcfilt(d,x); 
stem(n,y)
axis([-10,50,-abs(max(y)*1.1),abs(max(y)*1.1)]);
xlabel('n');ylabel('h(n)');
title('LATTICE Filter Impulse Response');
pause;

%LATTICE Filter and chirp input signal
close;
n=[0:1000];
x=sin(2*pi/4000.*n.*n);
s=latcfilt(d,x);
subplot(2,1,1);plot(n,x)
xlabel('n');ylabel('input(n)');
axis([0,1000,-1.2,1.2])
title('LATTICE Chirp Response');
subplot(2,1,2);plot(n,s)
axis([0,1000,-1.2,1.2])
xlabel('n');ylabel('output(n)');
pause;
close;

% LATTICE algorithm realisation
n=[0:1000];
%x=randn(1,1001);         %szum
x=sin(2*pi/4000.*n.*n);  %chirp
%n=[0:100]; %x=[(n==0)];  %pulse
y=zeros(1,length(x));    
N=length(d);
hist=zeros(1,N+1);
histnew=zeros(1,N+1);

coef=d;                  % coef - LATTICE filter coeficients
for j=1:length(x),

   out=coef(1)*x(j);
   histnew(1)=out;
   for i=2:N,
      histnew(i)=coef(i)*out+hist(i-1);     
      out=out+hist(i-1)*coef(i);
      hist(i-1)=histnew(i-1);
   end;
   hist(i)=histnew(i);
   y(j)=out;
end;   
subplot(2,1,1);plot(n,x);
axis([-10,length(n),-abs(max(x)*1.2),abs(max(x)*1.2)])
xlabel('n');ylabel('x(n)');
title('LATTICE filter realisation');
subplot(2,1,2);plot(n,y);
axis([-10,length(n),-abs(max(y)*1.2),abs(max(y)*1.2)])
xlabel('n');ylabel('y(n)');
pause;
close;
