function paramobj()
%
%
%       function paramobj;
%
%
% Funkcja tworzy okienko dialogowe ktre umorzliwia edycj paramtrw
% obiektw radaru
%
% Wynik jest przekazywany w zmiennych globalnych
%
% Velocity - Prdko obiektw
% Distance - Odlegoci obiektw od radarul
% NumTarget - Ilo zdefiniowanych obiektw

MAXTARGET=10;

HandleCol=1;
ValueCol=2;

% definiwanych poprzez pola edycyjne

IndNumTarget=1;
IndCurrentTarget=IndNumTarget+1;
IndCurrentDisp=IndNumTarget+2;
IndVelocity=IndNumTarget+3;
IndDistance=IndNumTarget+4;

% Definicje staych wywoywanych z menu

IndMenu=IndDistance+1;
IndClose1=IndMenu+1;

% Definicje staych wywoywanych z Buttonow

IndOkButton=IndClose1+1;
IndCancelButton=IndOkButton+1;
IndApplyButton=IndOkButton+2;

% Definicje Menu Okienka

IndMenuWin=35;
IndMenuWinRar=IndMenuWin+1;
IndMenuWinSig=IndMenuWin+2;
IndMenuWinObj=IndMenuWin+3;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Zmienne globalne
%
%

global Velocity;
global Distance;
global NumTarget;
global WinParamObject; % Identyfikator okna z celami
global WinParamSignal; % Identyfikator okna ze sygnalem
global WinMain;                 % Identyfikator glownego okna

if exist('WinParamObject')
  if openwin(WinParamObject)==1
    return;
  end   
end 


WinParamObject=figure('Units','normalized','position',[0.25 0.25 .5 .5]);
set(WinParamObject,'Name','Parametry Celu','NumberTitle','Off');
set(WinParamObject,'DefaultTextFontName','Arial Cyr');
set(WinParamObject,'Menubar','none');

Velocity=[30 20]';
Distance=[10 5]';
NumTarget=2;

%----------------Menu Okienka--------------------------------

str=sprintf('objcb(%d)',IndClose1);
handlem=uimenu(gcf,'Label','Koniec!','Callback',str);
setusrd1(gcf,IndMenu,HandleCol,handlem);

%----------------MENU OKNA-------------------

str=sprintf('winmenu(%d)',IndMenuWin);
handlem=uimenu(gcf,'Label','&Okienka','Callback',str);
setusrd1(gcf,IndMenuWin,HandleCol,handlem);

%----------------MENU OKNA RAR-------------------

str=sprintf('winmenu(%d)',IndMenuWinRar);
handle=uimenu(handlem,'Label','&Radar','Callback',str);
setusrd1(gcf,IndMenuWinRar,HandleCol,handle);

%----------------MENU OKNA SIG-------------------

str=sprintf('winmenu(%d)',IndMenuWinSig);
handle=uimenu(handlem,'Label','&Sygnal','Callback',str);
%setusrd1(gcf,IndMenuWinSig,HandleCol,handle);

%----------------MENU OKNA OBJ-------------------

str=sprintf('winmenu(%d)',IndMenuWinObj);
handle=uimenu(handlem,'Label','&Objekty','Callback',str);
setusrd1(gcf,IndMenuWinObj,HandleCol,handle);

%-----------------RAMKA--------------------------

%Frame=uicontrol('Style','fram','String','Prama.','Units','normalized',...
%'Position',[.70 .00 .3 1],...
%'BackgroundColor','red');


%-----------------NumTarget ID 1--------------------------

uicontrol('Style','text','String','Ilo obiektw :','Units','normalized',...
'Position',[.10 .80 .35 .10]);
handle=uicontrol('Style','edit','String',num2str(2),'Units','normalized',...
'Position',[.45 .80 .05 .10]);
str=sprintf('objcb(%d)',IndNumTarget);
set(handle,'Callback',str);
setusrd1(gcf,IndNumTarget,HandleCol,handle);

%-----------------CurrentTarget ID 2 display ID 3---------------

DispSlider=uicontrol('Style','text','String',['Aktualny cel :',num2str(1)],'Units','normalized',...
'Position',[.60 .90 .30 .07]);

CurrentSlider=uicontrol('Style','slider','Min',1,'Max',2,'Value',1,'Units','normalized',...
'Position',[.60 .80 .30 .07]);

str=sprintf('objcb(%d)',IndCurrentDisp);
set(DispSlider,'Callback',str);
str=sprintf('objcb(%d)',IndCurrentTarget);
set(CurrentSlider,'Callback',str);
setusrd1(gcf,IndCurrentTarget,HandleCol,CurrentSlider);
setusrd1(gcf,IndCurrentDisp,HandleCol,DispSlider);

%-----------------Velocity ID 4--------------------------

uicontrol('Style','text','String','Podaj prdko obiektu (m/s):','Units','normalized',...
'Position',[.10 .65 .80 .10]);
handle=uicontrol('Style','edit','String',num2str(0),'Units','normalized',...
'Position',[.10 .50 .80 .10]);
str=sprintf('objcb(%d)',IndVelocity);
set(handle,'Callback',str);
setusrd1(gcf,IndVelocity,HandleCol,handle);

%-----------------Distance ID 5--------------------------

uicontrol('Style','text','String','Podej odlego do celu (km):','Units','normalized',...
'Position',[.10 .35 .80 .10]);
handle=uicontrol('Style','edit','String','','Units','normalized',...
'Position',[.10 .20 .80 .10]);
str=sprintf('objcb(%d)',IndDistance);
set(handle,'Callback',str);
setusrd1(gcf,IndDistance,HandleCol,handle);


%-----------------Ok Anuluj Apply ID 6, 7 i 8--------------------------

str=sprintf('objcb(%d)',IndOkButton);
handle=uicontrol('Style','PushButton','String','OK','Units','normalized',...
'Position',[.08 .05 .25 .1 ],'Callback',str);
setusrd1(gcf,IndOkButton,HandleCol,handle);

str=sprintf('objcb(%d)',IndCancelButton);
CancelButton=uicontrol('Style','PushButton','String','Anuluj','Units','normalized',...
'Position',[.41 .05 .25 .1],'CallBack',str);
setusrd1(gcf,IndCancelButton,HandleCol,CancelButton);

str=sprintf('objcb(%d)',IndApplyButton);
ApplyButton=uicontrol('Style','PushButton','String','Zastosuj','Units','normalized',...
'Position',[.76 .05 .25 .1],'CallBack',str);
setusrd1(gcf,IndApplyButton,HandleCol,ApplyButton);

% Namaluj wszystkie Elementy
objcb(-1);
