function rarcb(NumUicontrol,arg2)
%
%
%       function rarcb(NumUicontrol,arg2)
%
%
% Funkcja zapewnia obsluge wywoan z menu i elementow kontrolnych
% dla okna obslugujacego parametry sygnalu chirp
% NumUicontrol == -1 - Wstepna inicjalizacjaq
% NumUicontrol ==  0 - przemalowanie calego obiektu
% NumUicontrol ==  >0 - nastpio wywoanie od jakiego
%                       elementu kontrolnego

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
% DEFINICJE STALYCH
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

MAXTARGET=10;
HandleCol=1;
ValueCol=2;

% definiwanych poprzez pola edycyjne

IndRadarFreq=1;
IndFFTnum=IndRadarFreq+1;
IndDiscFFTnum=IndRadarFreq+2;
IndCurrentPulse=IndRadarFreq+3;
IndSignalNoise=IndRadarFreq+4;

% definiwanych poprzez pola radio button

IndStep1=IndSignalNoise+1;
IndStep2=IndStep1+1;
IndStep3=IndStep1+2;
IndStep4=IndStep1+3;
IndStep5=IndStep1+4;
IndStep6=IndStep1+5;

% Definicje staych wywoywanych z menu

IndMenu=IndStep6+1;
IndClose1=IndMenu+1;
IndReal=IndMenu+2;
IndImag=IndMenu+3;
IndAbs=IndMenu+4;
IndAngle=IndMenu+5;
IndFFT_Shift=IndMenu+6;
IndFFT_Fun=IndMenu+7;
IndCursorOff=IndMenu+8;
IndCursorOn=IndMenu+9;
IndCursorStart=IndMenu+10;
IndZoomOn=IndMenu+11;
IndZoomOff=IndMenu+12;
IndTarget=IndMenu+13;
IndClose2=IndMenu+14;

% Definicje staych wywoywanych z Buttonow

IndOkButton=IndClose2+1;
IndCancelButton=IndOkButton+1;
IndApplyButton=IndOkButton+2;

% Definicje stalych typu dummy do przechowywania danych

IndRadarX=IndApplyButton+1;
IndRadarY=IndRadarX+1;
IndRadarC=IndRadarX+2;
IndRadarB=IndRadarX+3;

% Definicje stalych do uzywania ruchu kursora

IndCursor=IndRadarB+1;
IndDisplay=IndCursor+1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%                       Stale typu druga zmienna




%---------------Global

global WinParamSignal                           %Identyfikator Okienka
global WinParamObject                           %Identyfikator Okienka z parametrami
global WinMain                                          %Identyfikator glownego Okienka


global Velocity;
global Distance;
global NumTarget;

global PulseWidth;                                      %us
global PulseBwidth;                                     %MHz
global FreqSample;                                      %MHz
global InterPperiod;                            %us
global PulseNum;

if NumUicontrol == -1

%-------Przypisanie wartosci poczatkowych

        %Element typu Edit i Radio Buttons
        RadarFreq=10000;                                %MHz
        FFTnum=0;

        %Elsementy Radio Buttons
        Step1=IndStep1;
        Step2=0;
        Step3=0;
        Step4=0;
        Step5=0;
        Step6=0;

        %Elementy z Menu
        fun=IndReal;             %mozliwe wartosci abs|real|imag|angle
        FFT_Shift=0;
        FFT_Fun=0;
        noise=0;
        pulsenum=1;
        tarnum=1;

%
%
% Zapisz Wartoci pocztkowe
%
%


        setusrd2(gcf,IndCurrentPulse,HandleCol,[]);
        setusrd1(gcf,IndCurrentPulse,ValueCol,pulsenum);
        setusrd2(gcf,IndTarget,HandleCol,[]);
        setusrd1(gcf,IndTarget,ValueCol,tarnum);
        setusrd1(gcf,IndRadarFreq,ValueCol,RadarFreq);
        setusrd1(gcf,IndFFTnum,ValueCol,FFTnum);
        setusrd1(gcf,IndSignalNoise,ValueCol,noise);
        setusrd1(gcf,IndStep1,ValueCol,Step1);
        setusrd1(gcf,IndStep2,ValueCol,Step2);
        setusrd1(gcf,IndStep3,ValueCol,Step3);
        setusrd1(gcf,IndStep4,ValueCol,Step4);
        setusrd1(gcf,IndStep5,ValueCol,Step5);
        setusrd1(gcf,IndStep6,ValueCol,Step6);

        setusrd1(gcf,IndAbs,ValueCol,0);
        setusrd1(gcf,IndReal,ValueCol,0);
        setusrd1(gcf,IndImag,ValueCol,0);
        setusrd1(gcf,IndAngle,ValueCol,0);
        setusrd1(gcf,IndReal,ValueCol,fun);

        setusrd1(gcf,IndFFT_Shift,ValueCol,FFT_Shift);
        setusrd1(gcf,IndFFT_Fun,ValueCol,FFT_Fun);

        setusrd2(gcf,IndRadarX,HandleCol,[]);
        setusrd2(gcf,IndRadarY,HandleCol,[]);
        setusrd2(gcf,IndRadarC,HandleCol,[]);
        setusrd2(gcf,IndRadarB,HandleCol,[]);

        rarcb(0);
elseif NumUicontrol== 0
%
%
%   Pobierz wartosci z poszczegolnych pozycji i zapisz w odpowiednich
%       elementach
%
%


        Maxsh=getusrd2(gcf,IndCurrentPulse,HandleCol);
%        if Maxsh==[]
         if isempty(Maxsh)
         handle=getusrd1(gcf,IndCurrentPulse,HandleCol);
                str='wszystkie|razem';
                if PulseNum<1
                        disp('Musi byc co najmniej 1 impuls!!');
                        PulseNum=1;
                end
                for i=1:PulseNum
                        str=[str,'|Impuls ',num2str(i)];
                end
                set(handle,'String',str);
                setusrd2(gcf,IndCurrentPulse,HandleCol,PulseNum);
                num=getusrd1(gcf,IndCurrentPulse,ValueCol);
                if num>PulseNum
                        setusrd1(gcf,IndCurrentPulse,ValueCol,PulseNum);
                end
        end
%
%
% Zapisz i sprawdz wartosci do pozycji menu
%
%
        val1=getusrd1(gcf,IndReal,ValueCol);
        valstr1='off';
        valstr2='off';
        valstr3='off';
        valstr4='off';
        i=0;
        funn='';
        if val1==IndReal
                i=i+1;
                valstr1='on';
                funn='real';
        end
        if val1==IndImag
                i=i+1;
                valstr2='on';
                funn='imag';
        end
        if val1==IndAbs
                i=i+1;
                valstr3='on';
                funn='abs';
        end
        if val1==IndAngle
                i=i+1;
                valstr4='on';
                funn='angle';
        end
        if i~=1
                disp('Ciekaw(e) jak to mozliwe ze clikniete sa 2 opcje, albo');
                disp('Ciekaw(e) jak to mozliwe ze nie sa zaznaczone zadne opcje');
                val1=IndAbs;
                funn='abs';
                valstr1='off';
                valstr2='off';
                valstr3='on';
                valstr4='off';
        end
        setusrd1(gcf,IndReal,ValueCol,val1);
        set(getusrd1(gcf,IndReal,HandleCol),'Checked',valstr1);
        set(getusrd1(gcf,IndImag,HandleCol),'Checked',valstr2);
        set(getusrd1(gcf,IndAbs,HandleCol),'Checked',valstr3);
        set(getusrd1(gcf,IndAngle,HandleCol),'Checked',valstr4);

        val2=getusrd1(gcf,IndFFT_Shift,ValueCol);
        if (val2==0) | (val2==1)
                if val2==1
                        str='on';
                else
                        str='off';
                end
                set(getusrd1(gcf,IndFFT_Shift,HandleCol),'Checked',str);
        else
                disp('Niespojnisc w programie wylaczam FFT shift');
                set(getusrd1(gcf,IndFFT_Shift,HandleCol),'Checked','off');
                setusrd1(gcf,IndFFT_Shift,ValueCol,0);
        end

        val3=getusrd1(gcf,IndFFT_Fun,ValueCol);
        if (val3==0) | (val3==1)
                if val3==1
                        str='on';
                else
                        str='off';
                end
                set(getusrd1(gcf,IndFFT_Fun,HandleCol),'Checked',str);
        else
                disp('Niespojnisc w programie wylaczam FFT shift');
                set(getusrd1(gcf,IndFFT_Fun,HandleCol),'Checked','off');
                setusrd1(gcf,IndFFT_Fun,ValueCol,0);
        end

        Step=getusrd1(gcf,IndStep1,ValueCol);
        if Step==IndStep1|Step==IndStep2|Step==IndStep3|Step==IndStep4|...
                        Step==IndStep5|Step==IndStep6
                set(getusrd1(gcf,IndStep1,HandleCol),'Value',IndStep1==Step);
                set(getusrd1(gcf,IndStep2,HandleCol),'Value',IndStep2==Step);
                set(getusrd1(gcf,IndStep3,HandleCol),'Value',IndStep3==Step);
                set(getusrd1(gcf,IndStep4,HandleCol),'Value',IndStep4==Step);
                set(getusrd1(gcf,IndStep5,HandleCol),'Value',IndStep5==Step);
                set(getusrd1(gcf,IndStep6,HandleCol),'Value',IndStep6==Step);
        else
                disp('Nie spojnosc w programie, nastapi korekcja');
                set(getusrd1(gcf,IndStep1,HandleCol),'Value',IndStep1);
                set(getusrd1(gcf,IndStep2,HandleCol),'Value',0);
                set(getusrd1(gcf,IndStep3,HandleCol),'Value',0);
                set(getusrd1(gcf,IndStep4,HandleCol),'Value',0);
                set(getusrd1(gcf,IndStep5,HandleCol),'Value',0);
                set(getusrd1(gcf,IndStep6,HandleCol),'Value',0);
                setusrd1(gcf,IndStep1,ValueCol,IndStep1);
                Step=IndStep1;
        end

        ax=getusrd2(gcf,IndRadarX,HandleCol);
        ay=getusrd2(gcf,IndRadarY,HandleCol);
        ac=getusrd2(gcf,IndRadarC,HandleCol);
        ab=getusrd2(gcf,IndRadarB,HandleCol);


        num=getusrd1(gcf,IndFFTnum,ValueCol);
        num
        noise=getusrd1(gcf,IndSignalNoise,ValueCol);
        noise
        curnum=getusrd1(gcf,IndCurrentPulse,ValueCol);
        curnum
        if val3==1
                if num>0
                        x='fft(xx,num)'
                else
                        x='fft(xx)'
                end
                if val2==1
                        x=['fftshift(',x,')'];
                end
        else
                x='xx';
        end
        if val1==IndAbs
                x=['abs(',x,')'];
        elseif val1==IndReal
                x=['real(',x,')'];
        elseif val1==IndImag
                x=['imag(',x,')'];
        elseif val1==IndAngle
                x=['angle(',x,')'];
        else
                disp('nie znana funkcja???');val1
        end

T = PulseWidth;     % microsec
W = PulseBwidth;      % MHz
fs = FreqSample;    % MHz, oversample by 2
p=fs/W;
s = chirp(T, W, fs/W);
N=length(s);
f = mfchirp(T, W, fs/W);
Np = PulseNum;               % 7 pulses
Np =getusrd2(gcf,IndCurrentPulse,HandleCol);
jkl = 0:(Np-1);
T_w = InterPperiod;        % in usec
M=round(T_w*fs);
g = ones(1,Np);       % gains
T_out = [0 1399.9];    % in usec nie wazne
T_ref = 0;            % why use anything else?
fc = getusrd1(gcf,IndRadarFreq,ValueCol);           % 10 GHz

ranges = Distance     % in km ???
vels = Velocity       % in m/sec
amps = ones(size(vels));


        if isempty(ax) | isempty(ay) | isempty(ac) | isempty(ab)
                ax=series(s,M,Np,1);
                setusrd2(gcf,IndRadarX,HandleCol,ax);
                ay = rar(s,fs,T_w,g,T_out,T_ref,fc,ranges,amps,vels,noise);
                setusrd2(gcf,IndRadarY,HandleCol,ay);
                ac = rconv(ay,f);
                setusrd2(gcf,IndRadarC,HandleCol,ac);
                ab = pkpeaks(ac);
                setusrd2(gcf,IndRadarB,HandleCol,ab);
                [Mb Nb]=size(ab);
                Maxt=getusrd2(gcf,IndTarget,HandleCol);
               
                if Maxt ~=Mb
               % if isempty
                   handle=getusrd1(gcf,IndTarget,HandleCol);
                        if Mb<1
                                str='Brak Obie.';
                                disp('Brak zidentyfikopwanych obiektow');
                        else
                                str='Obiekt 1';
                                for i=2:Mb
                                        str=[str,'|Obiekt ',num2str(i)];
                                end
                        end
                        set(handle,'String',str);
                        setusrd2(gcf,IndTarget,HandleCol,Mb);
                        num=getusrd1(gcf,IndTarget,ValueCol);
                        if num>Mb
                                setusrd1(gcf,IndTarget,ValueCol,Mb);
                        end
                end
        end

        curtarget=getusrd1(gcf,IndTarget,ValueCol);
        curtarget
%
%
% Zapisz i sprawdz wartosci do pozycji menu
        %end

if Step==IndStep1
        if curnum>0&curnum<=Np
                xx=ax(:,curnum);
        elseif curnum==0
                xx=ax;
        elseif curnum==-1
                xx=ax(:);
        else
                disp('Niedopuszscalna wartosc curnum');curnum
        end
        xx=eval(x);
        t=getlmt1(xx,val3,val2,num,fs,0);
        plot(t,xx);
        limits(t,xx);
        if val3==1
                xlabel('czestotliwosc(MHz)');
        else
                xlabel('czas(us)');
        end
        title(x);
elseif  Step==IndStep2
        if curnum>0&curnum<=Np
                xx=ay(:,curnum);
        elseif curnum==0
                xx=ay;
        elseif curnum==-1
                xx=ay(:);
        else
                disp('Niedopuszscalna wartosc curnum');curnum
        end
        xx=eval(x);
        t=getlmt1(xx,val3,val2,num,fs,0);
        plot(t,xx);
        limits(t,xx);
        if val3==1
                xlabel('czestotliwosc(MHz)');
        else
                xlabel('czas(us)');
        end
        title(x);
elseif  Step==IndStep3
        if curnum>0&curnum<=Np
                xx=ac(:,curnum);
        elseif curnum==0
                xx=ac;
        elseif curnum==-1
                xx=ac;
                xx=mergecnv(ay,ac);
        else
                disp('Niedopuszscalna wartosc curnum');curnum
        end
        xx=eval(x);
        t=getlmt1(xx,val3,val2,num,fs,0);
        plot(t,xx);
        limits(t,xx);
        if val3==1
                xlabel('czestotliwosc(MHz)');
        else
                xlabel('czas(us)');
        end
        title(x);
        ab
        v = vel(ay,ac,ab,fs,fc,1024)
        d = dis(ac,T,W,p,ab,fs)
elseif  Step==IndStep4
        ab
        bb=zeros(size(ac));
        [Mb Nb]=size(ab);
        for j=1:Mb;
                for i=1:Nb % po wierszach
                        if ab(j,i)>0
                                bb(ab(j,i),i)=abs(ac(ab(j,i),i));
                        end
                end
        end
        getind(ab)
        if curnum>0&curnum<=Np
                t=getlmt1(bb,0,val2,num,fs,0);
                stem(t,bb(:,curnum));
                bb=bb(:,curnum);
        elseif curnum==0
                getind(ab)
                t=getlmt1(bb,0,val2,num,fs,0);
                stemm(t,bb);
                bb=bb(:);
        elseif curnum==-1
                t=getlmt1(bb(:),0,val2,num,fs,0);
                stem(t,bb(:));
                bb=bb(:);
        else
                disp('Niedopuszscalna wartosc curnum');curnum
        end
        limits(t,bb);
        xlabel('czas(us)');
elseif  Step==IndStep5
        ab
        [d l0]= dis(ac,T,W,p,ab,fs)
        [Mb Nb]=size(ab);
        bb=zeros(size(ac));
        bb2=bb;
        maxx=max(max(abs(ac)));
        for i=1:Nb % po wierszach
                for j=1:Mb;
                        if ab(j,i)>0
                                bb(ab(j,i),i)=abs(ac(ab(j,i),i));
                        end
                end
                bb2(l0,i)=maxx;
        end
        getind(ab)
        if curnum>0&curnum<=Np
                t=getlmt1(bb,0,val2,num,fs,l0-1)/2*.3;
                stem(t,bb(:,curnum));
                bb=bb(:,curnum);
                hold on
                stem(t,bb2(:,curnum),'-.');
                hold off;
        elseif curnum==0
                t=getlmt1(bb,0,val2,num,fs,l0-1)/2*.3;
                stemm(t,bb);
                bb=bb(:);
                hold on;
                stemm(t,bb2,'-.');
                hold off;
        elseif curnum==-1
                t=getlmt1(bb(:),0,val2,num,fs,l0-1)/2*.3;
                stem(t,bb(:));
                bb=bb(:);
                hold on;
                stem(t,bb2(:),'-.');
                hold off;
        else
                disp('Niedopuszscalna wartosc curnum');curnum
        end
        limits(t,bb2);
        %rarcb(IndCursor,ArgInit);
        xlabel('odleglosc(km)');
elseif  Step==IndStep6
        [My Ny]=size(ay);
        cnvsize=My*Ny+length(f)-1
        b = pkpeaks(ac);
        if num>0
                [v vv]= vel(ay,ac,b,fs,fc,num)
        else
                [v vv]= vel(ay,ac,b,fs,fc)
        end
        xx=vv(:,curtarget);
        xx=eval(x);
        if val3==1
                if val2==1
                        t=getlmt2(xx,val3,val2,num,fs*Ny/cnvsize,0);
                        if fc>0
                                t=t*.3e9/2/fc;
                        else
                                end
                        title('');
                        stem(t,xx);
                        xlabel('predkosc (m/s)');
                        %rarcb(IndCursor,ArgInit);
                else
                        %rarcb(IndCursor,ArgEnd);
                        t=getlmt1(xx,val3,val2,num,fs*Ny/cnvsize,0);
                        stem(t,xx);
                        xlabel('czestotliwosc (MHz)');
                end
                limits(t,xx)
                xlabel('');
        else
                %rarcb(IndCursor,ArgEnd);
                stem(xx);
        end
else
        disp('Nie spojnosc w programie, nieznany krok');
end



%
%
% Wyswietl wszystko tak jak ma byc
%
%


        num=getusrd1(gcf,IndCurrentPulse,ValueCol);
        set(getusrd1(gcf,IndCurrentPulse,HandleCol),'Value',num+2);
        val=getusrd1(gcf,IndSignalNoise,ValueCol);
        set(getusrd1(gcf,IndSignalNoise,HandleCol),'String',sprintf('%.10g',val));
        val=getusrd1(gcf,IndRadarFreq,ValueCol);
        set(getusrd1(gcf,IndRadarFreq,HandleCol),'String',sprintf('%.10g',val));
        numFFT=getusrd1(gcf,IndFFTnum,ValueCol);
        set(getusrd1(gcf,IndFFTnum,HandleCol),'String',sprintf('%d',numFFT));

elseif NumUicontrol == IndRadarFreq
        val=getnum3(getusrd1(gcf,IndRadarFreq,HandleCol));
        if val >=0
                setusrd1(gcf,IndRadarFreq,ValueCol,val);
        else
                disp('1:Nie mozna przeksztalcic wyraania na liczbe');
        end
        rarcb(0);
elseif NumUicontrol == IndFFTnum
        num=getnum1(getusrd1(gcf,IndFFTnum,HandleCol));
        if num >=0
                setusrd1(gcf,IndFFTnum,ValueCol,num);
        else
                disp('2:Nie mozna przeksztalcic wyraania na liczbe');
        end
        rarcb(0);
elseif NumUicontrol == IndCurrentPulse
        num=getnum4(getusrd1(gcf,IndCurrentPulse,HandleCol));
        %num=get(gco,'Value');
        setusrd1(gcf,IndCurrentPulse,ValueCol,num-2);
        rarcb(0);
elseif NumUicontrol == IndSignalNoise
        noise=getnum3(getusrd1(gcf,IndSignalNoise,HandleCol));
        if noise >=0
                setusrd1(gcf,IndSignalNoise,ValueCol,noise);
        else
                disp('2:Nie mozna przeksztalcic wyraania na liczbe');
        end
        rarcb(0);
elseif NumUicontrol == IndMenu
        %rarcb(0);
elseif NumUicontrol == IndAbs
        setusrd1(gcf,IndReal,ValueCol,IndAbs);
        rarcb(0);
elseif NumUicontrol == IndReal
        setusrd1(gcf,IndReal,ValueCol,IndReal);
        rarcb(0);
elseif NumUicontrol == IndImag
        setusrd1(gcf,IndReal,ValueCol,IndImag);
        rarcb(0);
elseif NumUicontrol == IndAngle
        setusrd1(gcf,IndReal,ValueCol,IndAngle);
        rarcb(0);
elseif NumUicontrol == IndFFT_Shift
        val1=getusrd1(gcf,IndFFT_Shift,ValueCol);
        setusrd1(gcf,IndFFT_Shift,ValueCol,~val1);
        rarcb(0);
elseif NumUicontrol == IndFFT_Fun
        val1=getusrd1(gcf,IndFFT_Fun,ValueCol);
        setusrd1(gcf,IndFFT_Fun,ValueCol,~val1);
        rarcb(0);
elseif NumUicontrol == IndStep1
        setusrd1(gcf,IndStep1,ValueCol,IndStep1);
        rarcb(0);
elseif NumUicontrol == IndStep2
        setusrd1(gcf,IndStep1,ValueCol,IndStep2);
        rarcb(0);
elseif NumUicontrol == IndStep3
        setusrd1(gcf,IndStep1,ValueCol,IndStep3);
        rarcb(0);
elseif NumUicontrol == IndStep4
        setusrd1(gcf,IndStep1,ValueCol,IndStep4);
        rarcb(0);
elseif NumUicontrol == IndStep5
        setusrd1(gcf,IndStep1,ValueCol,IndStep5);
        rarcb(0);
elseif NumUicontrol == IndStep6
        setusrd1(gcf,IndStep1,ValueCol,IndStep6);
        setusrd1(gcf,IndFFT_Fun,ValueCol,1);
        setusrd1(gcf,IndFFT_Shift,ValueCol,1);
        setusrd1(gcf,IndReal,ValueCol,IndAbs);
        rarcb(0);
elseif NumUicontrol == IndClose1 | NumUicontrol == IndClose2
        close;
        closewin;
        clear global WinMain;
        clear global WinParamSignal;
        clear global WinParamObject;
elseif NumUicontrol == IndApplyButton
        setusrd2(gcf,IndRadarX,HandleCol,[])
        setusrd2(gcf,IndRadarY,HandleCol,[])
        setusrd2(gcf,IndRadarC,HandleCol,[])
        setusrd2(gcf,IndRadarB,HandleCol,[])
        setusrd2(gcf,IndCurrentPulse,HandleCol,[])
        rarcb(0);
elseif NumUicontrol == IndRadarX
        disp('Niemozliwe wywloanie typu callback RadarX'); NumUicontrol
elseif NumUicontrol == IndRadarY
        disp('Niemozliwe wywloanie typu callback RadarY'); NumUicontrol
elseif NumUicontrol == IndRadarC
        disp('Niemozliwe wywloanie typu callback RadarC'); NumUicontrol
elseif NumUicontrol == IndRadarB
        disp('Niemozliwe wywloanie typu callback RadarB'); NumUicontrol
elseif NumUicontrol == IndDisplay
        disp('Niemozliwe wywloanie typu callback Display'); NumUicontrol


elseif NumUicontrol == IndZoomOn
                        cursor off;
                        mzoom on;
elseif NumUicontrol == IndZoomOff
                        mzoom off;
elseif NumUicontrol == IndCursorOn
                        handle=getusrd1(gcf,IndDisplay,HandleCol);
                        cursor off;
                        cursor('on',handle);
elseif NumUicontrol == IndCursorStart
                        handle=getusrd1(gcf,IndDisplay,HandleCol);
                        cursor off;
                        cursor('start',handle);
elseif NumUicontrol == IndCursorOff
                cursor off;

elseif NumUicontrol == IndCursor
                disp('Brak parametru arg2 !!!!!!!!');

elseif NumUicontrol == IndTarget
                %menu('Masz jeszcze cos do wyboru?','Tak','Nie');

        num=getnum4(getusrd1(gcf,IndTarget,HandleCol));
        num=get(gco,'Value');
        setusrd1(gcf,IndTarget,ValueCol,num);
        rarcb(0);

else
        disp('Niemozliwe wywloanie typu callback'),NumUicontrol
end

