function sigcb(NumUicontrol)
%
%
%       function sigcb(NumUicontrol)
%
%
% Funkcja zapewnia obsluge wywoan z menu i elementow kontrolnych
% dla okna obslugujacego parametry sygnalu chirp
% NumUicontrol == -1 - Wstepna inicjalizacjaq
% NumUicontrol ==  0 - przemalowanie calego obiektu
% NumUicontrol ==  >0 - nastpio wywoanie od jakiego
%                       elementu kontrolnego


% DEFINICJE STALYCH
HandleCol=1;
ValueCol=2;
% definiwanych poprzez pola edycyjne

IndFFTnum=1;
IndFreqSample=IndFFTnum+1;
IndPulseWidth=IndFFTnum+2;
IndPulseBwidth=IndFFTnum+3;
IndPulseNum=IndFFTnum+4;
IndInterPperiod=IndFFTnum+5;
IndFreqShift=IndFFTnum+6;
IndNoise=IndFFTnum+7;

% Definicje staych wywoywanych z menu
IndMenu=IndNoise+1;
IndReal=IndMenu+1;
IndImag=IndMenu+2;
IndAbs=IndMenu+3;
IndAngle=IndMenu+4;
IndFFT_Shift=IndMenu+5;
IndFFT_Fun=IndMenu+6;
IndChirp=IndMenu+7;
IndMatched=IndMenu+8;
IndConv=IndMenu+9;
IndClose=IndMenu+10;

% Definicje staych wywoywanych z Buttonow
IndOkButton=IndClose+1;
IndCancelButton=IndOkButton+1;
IndApplyButton=IndOkButton+2;

%---------------Global

% Identyfikatory okienek
global WinMain
global WinParamSignal
global WinParamObject

global PulseWidth;                                      %us
global PulseBwidth;                                     %MHz
global FreqSample;                                      %MHz
global InterPperiod;                            %us
global PulseNum;

if NumUicontrol == -1

%-------Przypisanie wartosci poczatkowych

        %Element typu Edit
        %if ~exist('PulseWidth')
                PulseWidth=10;                                  %us
        %end
        %if ~exist('PulseBwidth')
                PulseBwidth=5;                                  %MHz
        %end
        %if ~exist('FreqSample')
                FreqSample=10;                                  %MHz
        %end
        %if ~exist('InterPperiod')
                InterPperiod=200;                               %us
        %end
        %if ~exist('PulseNum')
                PulseNum=8;
        %end

        FreqShift=00;                                   %MHz
        FFTnum=0;
        noise=0;

        %Elementy z Menu
        fun=IndReal;             %mozliwe wartosci abs|real|imag|angle
        fun_oper=IndChirp;       %mozliwe wartosci conv|chirp|mfchirp
        FFT_Shift=0;
        FFT_Fun=0;

%
%
% Zapisz Wartoci pocztkowe
%
%
        setusrd1(gcf,IndFreqShift,ValueCol,FreqShift);
        setusrd1(gcf,IndPulseWidth,ValueCol,PulseWidth);
        setusrd1(gcf,IndPulseBwidth,ValueCol,PulseBwidth);
        setusrd1(gcf,IndFreqSample,ValueCol,FreqSample);
        setusrd1(gcf,IndInterPperiod,ValueCol,InterPperiod);
        setusrd1(gcf,IndNoise,ValueCol,noise);
        setusrd1(gcf,IndPulseNum,ValueCol,PulseNum);
        setusrd1(gcf,IndFFTnum,ValueCol,FFTnum);

        setusrd1(gcf,IndAbs,ValueCol,0);
        setusrd1(gcf,IndReal,ValueCol,0);
        setusrd1(gcf,IndImag,ValueCol,0);
        setusrd1(gcf,IndAngle,ValueCol,0);
        setusrd1(gcf,IndReal,ValueCol,fun);

        setusrd1(gcf,IndFFT_Shift,ValueCol,FFT_Shift);

        setusrd1(gcf,IndFFT_Fun,ValueCol,FFT_Fun);

        setusrd1(gcf,IndChirp,ValueCol,0);
        setusrd1(gcf,IndConv,ValueCol,0);
        setusrd1(gcf,IndMatched,ValueCol,0);
        setusrd1(gcf,IndChirp,ValueCol,fun_oper);
        sigcb(0);
elseif NumUicontrol== 0
% Zapisz i sprawdz wartosci do pozycji menu
%
%
        val1=getusrd1(gcf,IndReal,ValueCol);
        valstr1='off';
        valstr2='off';
        valstr3='off';
        valstr4='off';
        i=0;
        funn='';
        if val1==IndReal
                i=i+1;
                valstr1='on';
                funn='real';
        end
        if val1==IndImag
                i=i+1;
                valstr2='on';
                funn='imag';
        end
        if val1==IndAbs
                i=i+1;
                valstr3='on';
                funn='abs';
        end
        if val1==IndAngle
                i=i+1;
                valstr4='on';
                funn='angle';
        end
        if i~=1
                disp('Ciekaw(e) jak to mozliwe ze clikniete sa 2 opcje, albo');
                disp('Ciekaw(e) jak to mozliwe ze nie sa zaznaczone zadne opcje');
                val1=IndAbs;
                funn='abs';
                valstr1='off';
                valstr2='off';
                valstr3='on';
                valstr4='off';
        end
        setusrd1(gcf,IndReal,ValueCol,val1);
        set(getusrd1(gcf,IndReal,HandleCol),'Checked',valstr1);
        set(getusrd1(gcf,IndImag,HandleCol),'Checked',valstr2);
        set(getusrd1(gcf,IndAbs,HandleCol),'Checked',valstr3);
        set(getusrd1(gcf,IndAngle,HandleCol),'Checked',valstr4);

        val2=getusrd1(gcf,IndFFT_Shift,ValueCol);
        if (val2==0) | (val2==1)
                if val2==1
                        str='on';
                else
                        str='off';
                end
                set(getusrd1(gcf,IndFFT_Shift,HandleCol),'Checked',str);
        else
                disp('Niespojnisc w programie wylaczam FFT shift');
                set(getusrd1(gcf,IndFFT_Shift,HandleCol),'Checked','off');
                setusrd1(gcf,IndFFT_Shift,ValueCol,0);
        end

        val3=getusrd1(gcf,IndFFT_Fun,ValueCol);
        if (val3==0) | (val3==1)
                if val3==1
                        str='on';
                else
                        str='off';
                end
                set(getusrd1(gcf,IndFFT_Fun,HandleCol),'Checked',str);
        else
                disp('Niespojnisc w programie wylaczam FFT shift');
                set(getusrd1(gcf,IndFFT_Fun,HandleCol),'Checked','off');
                setusrd1(gcf,IndFFT_Fun,ValueCol,0);
        end

        val4=getusrd1(gcf,IndChirp,ValueCol);
        i=0;
        valstr1='off';
        valstr2='off';
        valstr3='off';
        if val4==IndChirp
                i=i+1;
                valstr1='on';
        end
        if val4==IndMatched
                i=i+1;
                valstr2='on';
        end
        if val4==IndConv
                i=i+1;
                valstr3='on';
        end
        if i~=1
                disp('Ciekawe jak to mozliwe ze clikniete sa 2 opcje, albo');
                disp('Ciekawe jak to mozliwe ze nie sa zaznaczone zadne opcje');
                val4=IndChirp;
                valstr1='on';
                valstr2='off';
                valstr3='off';
        end
        setusrd1(gcf,IndChirp,ValueCol,val4);
        set(getusrd1(gcf,IndChirp,HandleCol),'Checked',valstr1);
        set(getusrd1(gcf,IndMatched,HandleCol),'Checked',valstr2);
        set(getusrd1(gcf,IndConv,HandleCol),'Checked',valstr3);


        Ts=getusrd1(gcf,IndInterPperiod,ValueCol);
        T=getusrd1(gcf,IndPulseWidth,ValueCol);
        if Ts<T
                disp(sprintf('Warunek %.10g < %.10g nie jest spelniony ',Ts,T));
                disp(sprintf('Rozszerzam szerokoci pomiedzy impulsami do %.10g ',T));
                Ts=T;
        end
        W=getusrd1(gcf,IndPulseBwidth,ValueCol);
        fs=getusrd1(gcf,IndFreqSample,ValueCol);
        noise=getusrd1(gcf,IndNoise,ValueCol);
        L=getusrd1(gcf,IndPulseNum,ValueCol);
        Nfft=getusrd1(gcf,IndFFTnum,ValueCol);
        w=getusrd1(gcf,IndFreqShift,ValueCol);
        N=round(T*fs);
        M=round(Ts*fs);
        p=fs/W;
        Nt=M*L;
        n=[1:Nt].';

        if val4==IndChirp
                x='chirp(T,W,p)';
                x='series(chirp(T,W,p),M,L)';
                y=eval(x);
                if w~=0
                        y=eval('y(n).*exp(j*w*(n-1))');
                        x=[x,'*exp(j*w*(n))'];
                end
                if noise>0
                        y=y+noise*(randn(size(y))+sqrt(-1)*randn(size(y)));
                end
        elseif val4==IndMatched
                x='mfchirp(T,W,p)';
                x='series(mfchirp(T,W,p),M,L)';
                y=eval(x);
                if w~=0
                        y=eval('y(n).*exp(j*w*(n-1))');
                        x=[x,'*exp(j*w*(n))'];
                end
        elseif val4==IndConv
                if w~=0
                        %y=eval('y(n).*exp(j*w*(n-1))');
                        x='conv(series(chirp(T,W,p),M,L).*exp(j*w*(n-1)),mfchirp(T,W,p))';
                        y=eval(x);
                        if noise>0
                                y=y+noise*(randn(size(y))+sqrt(-1)*randn(size(y)));
                        end
                else
                        x='conv(series(chirp(T,W,p),M,L),mfchirp(T,W,p))';
                        y=series(chirp(T,W,p),M,L);
                        if noise>0
                                y=y+noise*(randn(size(y))+sqrt(-1)*randn(size(y)));
                        end
                        y=conv(y,mfchirp(T,W,p));
                end
        else
                disp('Ciekawe jak to mozliwe ');
        end
        lab='czas(us)';
        if val3==1
                lab='czestotliwosc(Mhz)';
                if Nfft > 0
                        Nt=Nfft;
                        y=eval(['fft(y,',num2str(Nfft),')']);
                        x=['fft(',x,')',num2str(Nfft),')'];
                else
                        y=eval(['fft(y)']);
                        x=['fft(',x,')'];
                end
                if val2==1
                        y=eval(['fftshift(y)']);
                        x=['fftshift(',x,')'];
                end
        end
        y=eval([funn,'(y)']);
        x=[funn,'(',x,')'];
        t=getlmt1(y,val3,val2,Nfft,fs,0);
        plot(t,y);
        st=abs(max(t)-min(t));
        sy=abs(max(y)-min(y));
        axis([min(t)-.05*st max(t)+.05*st ...
                min(y)-.05*sy max(y)+.05*sy]);
        ylabel(x);
        xlabel(lab);


%
%
%   Pobierz wartosci z poszczegolnych pozycji i zapisz w odpowiednich
%       elementach
%
%
        val=getusrd1(gcf,IndFreqShift,ValueCol);
        set(getusrd1(gcf,IndFreqShift,HandleCol),'String',sprintf('%.10g',val));
        val=getusrd1(gcf,IndPulseWidth,ValueCol);
        set(getusrd1(gcf,IndPulseWidth,HandleCol),'String',sprintf('%.10g',val));
        val=getusrd1(gcf,IndPulseBwidth,ValueCol);
        set(getusrd1(gcf,IndPulseBwidth,HandleCol),'String',sprintf('%.10g',val));
        val=getusrd1(gcf,IndFreqSample,ValueCol);
        set(getusrd1(gcf,IndFreqSample,HandleCol),'String',sprintf('%.10g',val));
        val=getusrd1(gcf,IndInterPperiod,ValueCol);
        set(getusrd1(gcf,IndInterPperiod,HandleCol),'String',sprintf('%.10g',val));
        val=getusrd1(gcf,IndNoise,ValueCol);
        set(getusrd1(gcf,IndNoise,HandleCol),'String',sprintf('%.10g',val));
        val=getusrd1(gcf,IndPulseNum,ValueCol);
        set(getusrd1(gcf,IndPulseNum,HandleCol),'String',sprintf('%d',val));
        val=getusrd1(gcf,IndFFTnum,ValueCol);
        set(getusrd1(gcf,IndFFTnum,HandleCol),'String',sprintf('%d',val));
%
%

elseif NumUicontrol == IndFFTnum
        FFTnum=getnum1(getusrd1(gcf,IndFFTnum,HandleCol));
        if FFTnum >0
                Ts=getusrd1(gcf,IndInterPperiod,ValueCol);
                fs=getusrd1(gcf,IndFreqSample,ValueCol);
                L=getusrd1(gcf,IndPulseNum,ValueCol);
                Ns=round(Ts*L*fs);
                if Ns<FFTnum
                        setusrd1(gcf,IndFFTnum,ValueCol,FFTnum);
                else
                        disp(sprintf('1:Liczba prbek do FFT %d < %d szerokoci impulsu',FFTnum,Ns));
                end
        elseif FFTnum==0
                setusrd1(gcf,IndFFTnum,ValueCol,FFTnum);
        else
                disp('1:Nie mozna przeksztalcic wyraania na liczbe');
        end
        sigcb(0);
elseif NumUicontrol == IndFreqSample
        fs=getnum3(getusrd1(gcf,IndFreqSample,HandleCol));
        if fs >0
                FFTnum=getusrd1(gcf,IndFFTnum,ValueCol);
                Ts=getusrd1(gcf,IndInterPperiod,ValueCol);
                L=getusrd1(gcf,IndPulseNum,ValueCol);
                Ns=round(Ts*L*fs);
                W=getusrd1(gcf,IndPulseBwidth,ValueCol);
                if fs<W
                        disp(sprintf('2:Uwaga na aliasing %.10g < %.10g ',fs,W));
                end
                setusrd1(gcf,IndFreqSample,ValueCol,fs);
                if FFTnum>0 & FFTnum<Ns
                        disp(sprintf('2:Z powodu zmiany czest. liczba FFtnum jest mniejsze od calkowitej licz. %.10g < %.10g ',FFTnum,Ns));
                        disp(sprintf('2:Zmieniam FFTnum na 0 '));
                        setusrd1(gcf,IndFFTnum,ValueCol,0);
                end
        else
                disp('2:Nie mozna przeksztalcic wyraania na liczbe');
        end
        sigcb(0);
elseif NumUicontrol == IndPulseWidth
        val=getnum3(getusrd1(gcf,IndPulseWidth,HandleCol));
        if val >0
                Ts=getusrd1(gcf,IndInterPperiod,ValueCol);
                fs=getusrd1(gcf,IndFreqSample,ValueCol);
                if round(Ts*fs)<round(val*fs)
                        setusrd1(gcf,IndInterPperiod,ValueCol,val);
                        disp(sprintf('3:Szeroko impulsu %d > %d szerokoci pomiedzy impulsami',round(val*fs),round(Ts*fs)));
                        disp(sprintf('3:Rozszerzam szerokoci pomiedzy impulsami do %d',round(val*fs)));
                        FFTnum=getusrd1(gcf,IndFFTnum,ValueCol);
                        fs=getusrd1(gcf,IndFreqSample,ValueCol);
                        Ts=getusrd1(gcf,IndInterPperiod,ValueCol);
                        L=getusrd1(gcf,IndPulseNum,ValueCol);
                        Ns=round(Ts*L*fs);
                        if FFTnum>0 & FFTnum<Ns
                                disp(sprintf('3:Z powodu zmiany czest. liczba FFtnum jest mniejsze od calkowitej licz. %.10g < %.10g ',FFTnum,Ns));
                                disp(sprintf('3:Zmieniam FFTnum na 0 '));
                                setusrd1(gcf,IndFFTnum,ValueCol,0);
                        end
                end
                setusrd1(gcf,IndPulseWidth,ValueCol,val);
        else
                disp('3:Nie mozna przeksztalcic wyraania na liczbe');
        end
        sigcb(0);
elseif NumUicontrol == IndPulseBwidth
        val=getnum3(getusrd1(gcf,IndPulseBwidth,HandleCol));
        if val >0
                fs=getusrd1(gcf,IndFreqSample,ValueCol);
                if val>fs
                        disp(sprintf('4:Uwaga na aliasing %.10g > %.10g ',val,fs));
                end
                setusrd1(gcf,IndPulseBwidth,ValueCol,val);
        else
                disp('4:Nie mozna przeksztalcic wyraania na liczbe');
        end
        sigcb(0);
elseif NumUicontrol == IndPulseNum
        L=getnum1(getusrd1(gcf,IndPulseNum,HandleCol));
        if L >0
                FFTnum=getusrd1(gcf,IndFFTnum,ValueCol);
                Ts=getusrd1(gcf,IndInterPperiod,ValueCol);
                fs=getusrd1(gcf,IndFreqSample,ValueCol);
                Ns=round(Ts*L*fs);
                if FFTnum>0 & FFTnum<Ns
                        disp(sprintf('5:Z powodu zmiany liczby imp. FFtnum jest mniejsze od calkowitej licz. %.10g < %.10g ',FFTnum,Ns));
                        disp(sprintf('5:Zmieniam FFTnum na 0 '));
                        setusrd1(gcf,IndFFTnum,ValueCol,0);
                end
                setusrd1(gcf,IndPulseNum,ValueCol,L);
        else
                disp('5:Nie mozna przeksztalcic wyraania na liczbe');
        end
        sigcb(0);
elseif NumUicontrol == IndInterPperiod
        Ts=getnum3(getusrd1(gcf,IndInterPperiod,HandleCol));
        if Ts >0
                FFTnum=getusrd1(gcf,IndFFTnum,ValueCol);
                T=getusrd1(gcf,IndPulseWidth,ValueCol);
                fs=getusrd1(gcf,IndFreqSample,ValueCol);
                L=getusrd1(gcf,IndPulseNum,ValueCol);
                Ns=round(Ts*L*fs);
                if round(T*fs)>round(Ts*fs)
                        disp(sprintf('6:Szeroko impulsu %d > %d szerokoci pomiedzy impulsami',round(T*fs),round(Ts*fs)));
                        disp(sprintf('6:Nie rozszerzam szerokoci pomiedzy impulsami'));
                else
                        if FFTnum>0 & FFTnum<Ns
                                disp(sprintf('6:Z powodu zmiany InterPperiod, FFtnum jest mniejsze od calkowitej licz. %.10g < %.10g ',FFTnum,Ns));
                                disp(sprintf('6:Zmieniam FFTnum na 0 '));
                                setusrd1(gcf,IndFFTnum,ValueCol,0);
                        end
                        setusrd1(gcf,IndInterPperiod,ValueCol,Ts);
                end
        else
                disp('6:Nie mozna przeksztalcic wyraania na liczbe');
        end
        sigcb(0);
elseif NumUicontrol == IndFreqShift
        val=getnum3(getusrd1(gcf,IndFreqShift,HandleCol));
%        if val ~= []
         if ~isempty(val)
                setusrd1(gcf,IndFreqShift,ValueCol,val);
        else
                disp('7:Nie mozna przeksztalcic wyraania na liczbe');
        end
        sigcb(0);
elseif NumUicontrol == IndNoise
        val=getnum3(getusrd1(gcf,IndNoise,HandleCol));
        if val >=0
                setusrd1(gcf,IndNoise,ValueCol,val);
        else
                disp('8:Nie mozna przeksztalcic wyraania na liczbe');
        end
        sigcb(0);
elseif NumUicontrol == IndMenu
        %sigcb(0);
elseif NumUicontrol == IndAbs
        setusrd1(gcf,IndReal,ValueCol,IndAbs);
        sigcb(0);
elseif NumUicontrol == IndReal
        setusrd1(gcf,IndReal,ValueCol,IndReal);
        sigcb(0);
elseif NumUicontrol == IndImag
        setusrd1(gcf,IndReal,ValueCol,IndImag);
        sigcb(0);
elseif NumUicontrol == IndAngle
        setusrd1(gcf,IndReal,ValueCol,IndAngle);
        sigcb(0);
elseif NumUicontrol == IndFFT_Shift
        val1=getusrd1(gcf,IndFFT_Shift,ValueCol);
        setusrd1(gcf,IndFFT_Shift,ValueCol,~val1);
        sigcb(0);
elseif NumUicontrol == IndFFT_Fun
        val1=getusrd1(gcf,IndFFT_Fun,ValueCol);
        setusrd1(gcf,IndFFT_Fun,ValueCol,~val1);
        sigcb(0);
elseif NumUicontrol == IndChirp
        setusrd1(gcf,IndChirp,ValueCol,IndChirp);
        sigcb(0);
elseif NumUicontrol == IndMatched
        setusrd1(gcf,IndChirp,ValueCol,IndMatched);
        sigcb(0);
elseif NumUicontrol == IndConv
        setusrd1(gcf,IndChirp,ValueCol,IndConv);
        sigcb(0);
elseif NumUicontrol == IndClose | NumUicontrol == IndCancelButton
        WinParamSignal=0;
        close;
elseif NumUicontrol == IndOkButton
        PulseWidth=getusrd1(gcf,IndPulseWidth,ValueCol)
        PulseBwidth=getusrd1(gcf,IndPulseBwidth,ValueCol)
        FreqSample=getusrd1(gcf,IndFreqSample,ValueCol)
        InterPperiod=getusrd1(gcf,IndInterPperiod,ValueCol)
        PulseNum=getusrd1(gcf,IndPulseNum,ValueCol)
        WinParamSignal=0;
        close;
elseif NumUicontrol == IndApplyButton
        PulseWidth=getusrd1(gcf,IndPulseWidth,ValueCol)
        PulseBwidth=getusrd1(gcf,IndPulseBwidth,ValueCol)
        FreqSample=getusrd1(gcf,IndFreqSample,ValueCol)
        InterPperiod=getusrd1(gcf,IndInterPperiod,ValueCol)
        PulseNum=getusrd1(gcf,IndPulseNum,ValueCol)
else
        disp('Niemozliwe wywloanie typu callback');
end
