%
%   EXAMPLE of calling the function radar()
%     make one radar return for a burst of LFM pulses

%---------------------------------------------------------------
% copyright 1994, by C.S. Burrus, J.H. McClellan, A.V. Oppenheim,
% T.W. Parks, R.W. Schafer, & H.W. Schussler.  For use with the book
% "Computer-Based Exercises for Signal Processing Using MATLAB"
% (Prentice-Hall, 1994).
%---------------------------------------------------------------
%clear,  format compact
T = 10     % microsec
W = 5      % MHz
fs = 10    % MHz, oversample by 2
p=fs/W;
s = chirp(T, W, fs/W);
f = mfchirp(T, W, fs/W);
Np = 7;               % 7 pulses
jkl = 0:(Np-1);
T_w = 200;        % in usec
g = ones(1,Np);       % gains
T_out = [0 1399.9];    % in usec
T_ref = 0;            % why use anything else?
fc = 10000;           % 10 GHz
noise=0;

ranges = [ 20 3 ]     % in km ???
vels = [ 30 -10 ]       % in m/sec
amps = 1;

y = rar(s,fs,T_w,g,T_out,T_ref,fc,ranges,amps,vels,noise);
c = rconv(y,f);
b = pkpeaks(c);
v = vel(y,c,b,fs,fc)
d = dis(c,T,W,p,b,fs)

