function [v,x]=vel(y,c,b,fs,fc,num,str);
%
%
% function [v,x]=vel(y,c,b,fs,fc,<num>,<str>);
%
%	v = obliczone predkosci
%	x-	wartosci ktorebyly uzyte do policzenia v
%
%	y - macierz wyjscia z radaru (w kazdej kolumnie odp. od 1 impulsu)
%	c - macierz y po dzialaniu splotu (w kazdej splot od 1 impulsu)
%	b - maierz ze wskaznikami na poszczegolne "cele" w kolumnach
%	num-oznacza ilosc punktow do fft 0-oznacza fft=size(x)
%	fc- czetotliwosc radaru
%	str- ustawione na 'all' wymusza oliczenie predkosci dla wszyskich elementow.
%		dla wartosci z kazdej kolumny 
%	    'vel' oblicza wszystkie mozliwe predkosci
%	funkcja oblicza predkosc obiektu
%	na wyjsciu macierz v odpowiadajaca b
%

%Przetwoz argumnety domyslne
strall=0;
if nargin==7
	if strcmp(str,'all')
		strall=1;
	elseif strcmp(str,'vel') 
		strall=2;
	end
elseif nargin<6
	num=0;
end

x=[];
[Ma Mb]=size(b);
[Ca Cb]=size(c);
columns=1; %	wybierz ko jedna kolumne
rows=1:Ma; %	wybierz wszystkie wiersze
[val in]=getind(b);
if strall==1 %	wybierz wszystkie kolumny
	columns=1:Mb;
end
if strall==2 %	wybierz tylko jeden wiersz
	rows=1;
end
if num<Cb 		%num-liczba punktow do FFT
	num=Cb;
end;
h=num./2; % Polowa szerokosci FFT
for ii=columns
	for i = rows
		if strall==1
			Ind=b(i,ii);
		else
			Ind=val(i);
		end
		if Ind>0
			vek=c(Ind,:);
		else
			disp('Jakis zerowy index - ratunku !!!!!');
			vek=zeros(size(c(1,:)));
		end	
		if strall==0
			x(:,i)=vek.';
		end
		ff=fft(vek,num);
		[vv fftindex]=max(ff)
		if strall==2
			fftindex=1:num;
		end
		for jkl=fftindex
			ll=jkl;
			if rem(num,2)==0 %sprawdzenie czy parzysta czy nie parzysta liczba
				if ll==h+1
					%disp('aliasing przy predkosci');
				elseif ll<=h % predkosc dodatnia
					ll=ll-1;
				elseif jkl>h   % jkl>h  predkosc ujemna
					ll=-(num-ll+1);
				end
			else
				if ll<=h+1
					ll=ll-1;
				elseif jkl>h+1
					ll=-(num-ll+1);
				end
			end
			if strall==2
				v(i,jkl)=ll;
			else
				v(i,ii)=ll;
			end
		end
	end
end
if fc~=0
	v=v/num*Cb/(size(y,1)*size(y,2)+size(c,1)-size(y,1))*fs*.3e9/2/fc;
else
	disp('fc==0 Nie moge policzyc predkosci')
end
%v=mean(v');
