%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Transmisja cyfrowa w kanale 600..1500Hz w pasmie mowy ludzkiej
%% Autorzy : 
%% Przemyslaw Jodkowski & Michal Dusinski
%%%%%%%%%%%%%
%%% cale pasmo:     0  ..2400Hz ; (matlab:0    ..    1)
%%% pasmo wycinane: 600..1500Hz ; (matlab:0.250..0.625)

close all;

%%%%%%%%%%%%%
N=98;	  % Ilosc wspolczynnikow filtra
a=1;	  % mianownik filtra FIR
f1=0.250; % dolna granica kanalu - faktycznie: 600Hz
f2=0.625; % gorna granica kanalu - faktycznie: 1500Hz
fp=2;	  % czestotliwosc probkowania - faktycznie: 4800Hz
fd1=0.375;% 1 sygnal cyfrowy - faktycznie: 900Hz
fd2=0.500;% 1 sygnal cyfrowy - faktycznie: 1200Hz

%%%%%%%%%%%%%
%% definicje filtrow:
bstop=fir1(N,[f1,f2],'stop');
bpass=fir1(N,[f1,f2]);

%%%%%%%%%%%%%
%% Definicja sygnalow wej.:

%% odczytanie zmiennych xv,im,map z pliku source.mat:
load source
fsound = 22255;  %czestotliwosc probkowania dzwieku
nmax=length(xv);  % ilosc probek
n=[0:nmax-1];

%%% Transmisja dzwiekowa:
xvoice=xv(1:nmax);		

%%% Transmisja cyfrowa(900Hz/1200Hz):
sin1=sin(2*pi*fd1/fp*n(1:10000));
sin2=sin(2*pi*fd2/fp*n(1:10000));
sin3    (1:10000)=sin1(1:10000);
sin3(10001:20000)=sin2(1:10000);
for i=1:20000:nmax,
  xsin(i:i+19999)=127*sin3;
end

%%%%%%%%%%%%%
%% obliczenia:

%% wejscie:
v1=xvoice(1:nmax);
s1=xsin(1:nmax);

%% po filtrowaniu:
v2=filter(bstop,a,v1);
s2=filter(bpass,a,s1);

%% po sumowaniu:
sv3=(s2+v2)/2;

%% po filtrowaniu:
v4=filter(bstop,a,sv3)*2;
s4=filter(bpass,a,sv3)*2;

%%%%%%%%%%%%% 
%% Diagram:

diag=figure('Position',[50 50 650 250]);
set(diag,'Resize','off');
s=subplot(1,1,1);
set(s,'Units','Pixels','Position',[0 0 653 305]);
axis off;
image(im);
axis off;
colormap(map);

%%%%%%%%%%%%% Klawisze:
x1=8;
x2=230;
x3=330;
x4=580;
y1=185;
y2=72;
y3=127;
dx=60;
dy=20;
%%% V1:
fv1=0;
uicontrol('String','Voice',...
 	  'Units','Pixels',...
	  'Position',[x1 y1 dx dy],...
	  'Callback','firv1'); 
%%% S1:
fs1=0;
uicontrol('String','Sinus',...
 	  'Units','Pixels',...
	  'Position',[x1 y2 dx dy],...
	  'Callback','firs1'); 
%%% V2:
fv2=0;
uicontrol('String','Voice',...
 	  'Units','Pixels',...
	  'Position',[x2 y1 dx dy],...
	  'Callback','firv2'); 
%%% S2:
fs2=0;
uicontrol('String','Sinus',...
 	  'Units','Pixels',...
	  'Position',[x2 y2 dx dy],...
	  'Callback','firs2'); 
%%% SV3:
fsv3=0;
uicontrol('String','Mixed',...
 	  'Units','Pixels',...
	  'Position',[x3 y3 dx dy],...
	  'Callback','firsv3'); 
%%% V4:
fv4=0;
uicontrol('String','Voice',...
 	  'Units','Pixels',...
	  'Position',[x4 y1 dx dy],...
	  'Callback','firv4'); 
%%% S4:
fs4=0;
uicontrol('String','Sinus',...
 	  'Units','Pixels',...
	  'Position',[x4 y2 dx dy],...
	  'Callback','firs4'); 
%%% Exit:
uicontrol('String','Exit',...
 	  'Units','Pixels',...
	  'Position',[295 0 dx dy],...
	  'Callback','firexit'); 


%%%%%%%%%%
