function [Xk,w] = dtft(xn,n,k,N)
% Computes Discrete Time Fourier Transformation
% --------------------------------------------
% [Xk,w] = dtft(xn,n,k,N)
% Xk = DTFT coeff. array 
% xn = finite duration sequence
% n = sample position vector
% k = location of frequency position vector ( [0:N] is pi )
% N = circle divided at N points
w = (pi/N)*k;
Xk = xn * (exp(-j*pi/N)).^(n'*k);    % DTFT of x

