% iir_desi.m  : filtr iir forma bezp., kaskada
cascade=1;
direction= 'down';
N=100;


%[b,a]    = ellip(5,0.3,60.2,[0.2],'high'); %N-1, dB, dB, w <<<highpass
%[z,p,k]  = ellip(5,0.3,60.2,[0.2],'high');

%[b,a]    = ellip(5,0.3,40.2,[0.2,0.3],'stop' ); 
%[z,p,k]  = ellip(5,0.3,40.2,[0.2,0.3],'stop' );

%[b,a]    = butter(5,[0.2],'high'); %N-1,  w  <<<highpass
%[z,p,k]  = butter(5,[0.2],'high');

[b,a]    = butter(4,[0.5],'high'); %N-1,  w  <<<lowpass , allpass
[z,p,k]  = butter(4,[0.5],'high');

%[b,a]    = maxflat(3,3,[0.25],'high' );  % NB-1, NA-1, w <<< lowpass
%b=[ 1 0 0 0  -1]*(1/5);
%a=[ 1 0 1]
%z= roots(b);
%p= roots(a);
%
%k=1;

%[b,a]    = cheby2(5,100,[0.2], 'high'); %N-1, dB, w  <<<highpass
%[z,p,k]  = cheby2(5,100,[0.2], 'high');

%[b,a]    = cheby1(5,0.1,[0.2], 'high'); %N-1, dB, w  <<<highpass
%[z,p,k]  = cheby1(5,0.1,[0.2], 'high');


[H,w]=freqz(b,a,1024); 
subplot(2,2,1);
plot(w*2/(2*pi),20*log10(abs(H)));
grid on;
subplot(2,2,3);
plot(w*2/(2*pi),(angle(H)));
grid on;
subplot(2,2,2);
zplane(b,a);
grid on;
subplot(2,2,4);
impz(b,a,N,'.');
grid on;
disp( b);
disp( a);
pause;
clf;
x=[1 zeros(1,N-1)]
y=filter(b,a,x);
stem(y,'.');
grid on;
pause;


%  chirp signal

n=[0:1000];
x=sin(2*pi/5000.*n.*n);  %chirp

%x=wavread('c:\mat\car.wav');
y=filter(b,a,x);
pause
sound(x);
pause;
sound(y);
subplot(2,2,4);plot(n,y)
title('Chirp Response');xlabel('n');ylabel('y(n)')
axis([0,1000,-1.2,1.2])
subplot(2,2,3);plot(n,x)
title('Chirp');xlabel('n');ylabel('chirp(n)')
axis([0,1000,-1.2,1.2])
pause;
pause

clf;
    sos = zp2sos(z,p,k,direction);
    disp(sos);
    np = 256; m = size(sos,1);
    disp(m);
    h = []; H = zeros(np,m);
    [H(:,1),F] = freqz(sos(1,1:3),sos(1,4:6),np,2);
    x=ones(size(F));
    plot3(x,F,20*log10(abs(H(:,1))),'b');
    grid on;
    hold on;
    for i=2:m,
      if cascade,
         H(:,i) = H(:,i-1).*freqz(sos(i,1:3),sos(i,4:6),np,2);
         plot3(x.*i, F,20*log10(abs(H(:,i))),col(i));
      else
          H(:,i) = freqz(sos(i,1:3),sos(i,4:6),np,2);       
          plot3(x.*i, F,20*log10(abs(H(:,i))),col(i));

      end
    end
hold off;
    
pause;

% iir w postaci programu ---------------------------------------------
close;

n=[0:1000];
%x=randn(1,1001);        %szum
%x=sin(2*pi/5000.*n.*n);  %chirp
x=[(n==20)];           %impulse
%t=0:0.0001:1;
%x=chirp(t,0,1,10000);

y=zeros(1,length(x));
NN=m;
hist=zeros(NN,2);
coef = sos;
for j=1:length(x),
    out = x(j) ;     

    for i = 1 : NN, 
        history1 = hist(i,1);           %/* history values */
        history2 = hist(i,2);

         new_hist = out      * coef(i,4) - history1 * coef(i,5) - history2 * coef(i,6) ;  % poles 
         out      = new_hist * coef(i,1) + history1 * coef(i,2) + history2 * coef(i,3) ;  % zeros 
        hist(i,2) = hist(i,1);
        hist(i,1) = new_hist;
     end;   
     y(j)=out;      
 end;
     
subplot(2,1,1);plot([0:length(x)-1],x)

%axis([400,800,-2,2]);

title('iir: input');xlabel('n');ylabel('x(n)')

subplot(2,1,2);plot([0:length(y)-1],y)

%axis([0,1000,-2,2]);

title('iir: output ');xlabel('n');ylabel('y(n)')
pause;
sound(x);
pause;
sound(y);
pause;
%-------------------------------produce coeficient table
disp(sos)
fid=fopen('coef.dat','w');
fprintf(fid,' #define NN  %d\r\n',NN);
fprintf(fid,' const  float coef[NN][6] = {\r\n');
for i=1:NN,
   fprintf(fid,'    {');
   for j=1:6,
      fprintf(fid,'%12.6g ',sos(i,j));
      if  j==6  
       else 
          fprintf(fid,',');  
       end;   
   end;
     fprintf(fid,'},\r\n');
end;
fprintf(fid,' };\r\n');
fclose(fid);

