% sin2gen.m : Generacja 2 funkcji sinus. Wybieranie tonowe DTMF
%
%                                Column                                        _
%                           1       2       3       4                           _
%                        1209Hz  1336Hz   1477Hz  1633Hz                                                _
%                       +-----------------------+                              _
%                 1     |   1   |   2   |   3   |   A       697Hz                   _
%                       |       |       |       |                              _
%                       +-------+-------+-------+                              _
%                 2     |   4   |   5   |   6   |   B       770Hz                    _
%              R        |       |       |       |                              _
%              O        +-------+-------+-------+                              _
%              W  3     |   7   |   8   |   9   |   C       852Hz                    _
%                       |       |       |       |                              _
%                       +-------+-------+-------+                              _
%                 4     |   *   |   0   |   #   |   D       941Hz                    _
%                       |       |       |       |                              _
%                       +-----------------------+                              _
%
close;
n=1:10000;

N1=5;
A1=2*cos(2*pi/N1);
C1=sin(2*pi/N1);
y1=[0,C1,0];

N2=30;
A2=2*cos(2*pi/N2);
C2=sin(2*pi/N2);
y2=[0,C2,0];

for j=n,
   y1(3)=y1(2);
   y1(2)=y1(1);
   y1(1)=A1*y1(2)-y1(3);
   
   y2(3)=y2(2);
   y2(2)=y2(1);
   y2(1)=A2*y2(2)-y2(3);
   r(j)=y1(1)+ y2(1);

end;
grid on;
subplot(2,1,1);plot(n,r)
axis([0,100,-2,2])
title('sin & sin');xlabel('n');ylabel('out(n)')
pause;
sound(r);
close;







