%------------------------------------------------------------------
% Adaptive filter: LMS algorithm realisation
close;
n=[0:500];
%sinusoidal interference removal  (sin expected on output) -----
%   noise=sign(sin(2*pi/20.*n));   % try to remove sign()
%   noise=sin(2*pi/20.*n);   % try to remove sign()
%   d=sin(2*pi/200.*n)+noise;      % desired signal
%   x=[noise]/2;                   % input signal
%   M=0;                           % DEALY

%sinusoidal interference removal  (noise expected on output) -----
  % noise=randn(1,length(n))*0.2; % noise
  % d=sin(2*pi/20.*n)+noise;      % desired signal
  % x=d;
  % M=1;                          % DEALY

%LMS basic algorithm -----
   x=sin(2*pi/20.*n);
   d=2*cos(2*pi/20.*n);
   M=10
   ;                   %DEALY

%echo cancelation -----
  %nn=[0:50];
  %sig=sin(2*pi/10.*nn);
  %zer=zeros(1,50);
  %d=[sig,zer,sig*0.3,zer,sig*0.1,zer,sig,zer,sig*0.3];      % desired signal
  %x=d;         % input signal
  %M=50;        % DELAY

% x - input ; y - output ; hist - input history; w - filter coeficients; d-desired signal

u=0.01;
N=100;    % filter length

hist=zeros(1,N+1);
w=zeros(1,N);                  % coef - FIR filyrt coeficients
for j=1:length(d),
   hist(N+M+1)=x(j);

   for i=1:N+M,
      hist(i)=hist(i+1);  
   end;
   
   out=0;
   for i=1:N,
      out=out+hist(i)*w(N-i+1);    
   end;
   y(j)=out; 
   e(j) = d(j) - out;
   ue = 2*u*e(j);
   for i=1:N
      w(i)=w(i) + hist(N-i+1)*ue;
   end

end;   
subplot(4,1,1);plot(x);
axis([1,length(x),-abs(max(x)*1.2),abs(max(x)*1.2)])
xlabel('n');ylabel('x(n)');
title('Adaptive filter realisation');
subplot(4,1,2);plot(d);
axis([1,length(d),-abs(max(d)*1.2),abs(max(d)*1.2)])
xlabel('n');ylabel('d(n)');
subplot(4,1,3);plot(y);
axis([1,length(y),-abs(max(y)*1.2),abs(max(y)*1.2)])
xlabel('n');ylabel('y(n)');
subplot(4,1,4);plot(e);
axis([1,length(e),-abs(max(e)*1.2),abs(max(e)*1.2)])
xlabel('n');ylabel('e(n)');
pause;
subplot(1,1,1);
hold on;
%plot(x,'r');
plot(d,'g');
%plot(y,'b');
plot(e,'y');

hold off;

%-------------------------------produce coeficient table
pause;
stem(w);






