% ALGORYTM GOERTZEL'A
%   Obliczanie kwadratu amplitudy dla k-tej harmonicznej 
%   N-elementowego zbioru danych x.
function amp2= zgoer(x,N,k)
% zerowanie 2-elementowej historii w stanie pocztkowym
hist= zeros(1,2);
% wstpne obliczenie wspczynnika fact
factor=2*cos(2*pi*k/N);
% gwna ptla filtru dla N-elementowego zbioru x
for i=1:N,
   hist=[x(i)+factor*hist(1)-hist(2),hist(1)];
end;
% obliczenie kwadratu amplitudy po N obrotach filtru
% korzystajc z zawartoci historii
amp2=hist(1)*hist(1)+hist(2)*hist(2)-factor*hist(1)*hist(2);
