clear all;
maxn=1000;
ql=12;						% quantisation bits
n=[0:maxn-1];

s=sin(2*pi/maxn.*n);
%s=sin(10*2*pi/maxn.*n);
%s=sin(n/50)+0.2*sin(n/15);
%s=-1+2/maxn.*n;
%s=sign(n-maxn/2+0.00001);

ql=2^(ql-1)-1;				% quantisation levels in amplitude

sk(1)=s(1);					% original data vector
sa(1)=1;						% modulated data vector
ss(1)=s(1);					% restored data vector

so1=0.1;						% auxiliary variables
a2=0.1;
s1=0;
b2=0.1;
bold=0.1;

for i=2:maxn,
   
   sk(i)=round(s(i)*ql)/ql;	% quantisation in (-1..1)
   s0=sk(i);						% ADPCM input
   
   % ------------------  A D P C M  -------------------
   
   % ------ Encoder block -------
   s0=s0-so1;
   s0=sign(s0);
   sout=s0;
   
   a1=s0-s1;			% --- Step Size Adaptation ---
   if a1==0						% --- Factor correction
      a1=2*a2;
 	else
      a1=0.5*a2;
   end;
   if a1>0.5					% --- Saturation
      a1=0.5;
   end;
   if a1<0.01
      a1=0.01;
   end;
   a2=a1;
   s0=s0*a1;			% --- end SSA ---
   
   s1=sout;
   s0=s0+so1;
   so1=s0*0.99;
   
% ------ Chanel block ------
	sa(i)=sout;
   
% ------ Decoder block ------
	b1=sa(i)-sa(i-1);	% --- Step Size Adaptation ---
   if b1==0
      b1=2*b2;
   else
      b1=0.5*b2;
   end;
   if b1>0.5
      b1=0.5;
   end;
   if b1<0.01
      b1=0.01;
   end;
   b2=b1;
   b=b1*sout;			% --- end SSA ---
  
   b=b+bold;
   b=0.99*b;
   bold=b;
   
   % ------------------  end ADPCM  -------------------
	ss(i)=b;

end;

subplot(1,1,1); 
whitebg(1,[1 1 0.9]);
plot([1:maxn],sa,'r');
hold on;
plot([1:maxn],s,'b');
title('Modulacja ADPCM - sygna oryginalny i zmodulowany');
hold off;
pause;
plot([1:maxn],s,'b');
hold on;
plot([1:maxn],ss,'k');
title('Modulacja ADPCM - sygna oryginalny i zdemodulowany');
hold off;
err=(ss-s)*100;
pause;
plot([1:maxn],err,'b');
title('Modulacja ADPCM - rnica pomidzy sygnaem oryginalnym i zdemodulowanym');
ylabel ('%');
