clear all;
ql=4;										% number of A/D converter bits
u=255;									% PCM constant

maxn=1000;								% number of samples
n=[1:maxn];  							% data vector of maxn samples

% ------ Data ------
s=sin(2*pi/maxn.*n);
%s=sin(10*2*pi/maxn.*n);
%s=sin(n/50)+0.2*sin(n/15);
%s=-1+2/maxn.*n;
% ------------------

ql=2^(ql-1)-1;				% number of amplitude levels

% ------ initial data ------

sd(1)=s(1);				% signal after differential transformation
y1(1)=s(1);				% after PCM transformation
sk(1)=s(1);				% after quantisation
y2(1)=s(1);				% after dequantisation in restoring signal
sd2(1)=s(1);			% after PCM-1 transformation
s2(1)=s(1);				% after integral transformation
sp=s(1);					% integral transformation in error counting
e=0;						% DPCM transformation error

for i=2:maxn,
   
% ------ DPCM transformation ------   
   sd(i)=s(i)-s(i-1)+e;											% differential transformation
   y1(i)=(log(1+u*abs(sd(i)))/log(1+u))*sign(sd(i));	% PCM transformation
   sk(i)=round(y1(i)*ql);										% quantisation
   
% ------ error counting ------
   sdk=sk(i)/ql;													% dequantisation
   ss=((1+u)^abs(sdk)-1)/u*sign(sdk);						% PCM-1 transformation
   sp=sp+ss;														% integral transformation
   e=s(i)-sp;														% error counting
   
% ------ transmision chanel ------
% --------------------------------

% ------ DPCM-1 transformation ------
   y2(i)=sk(i)/ql;												% dequantisation
   sd2(i)=((1+u)^abs(y2(i))-1)/u*sign(y2(i)); 			% PCM-1 transformation
   s2(i)=s2(i-1)+sd2(i);										% integral transformation
end;

% ------ visualisation ------
subplot(1,1,1); 
whitebg(1,[1 1 0.9]);
plot([1:maxn],sk,'r');
hold on;
plot([1:maxn],s2,'b');
title('Modulacja DPCM - sygn. zmodulowany i odtworzony');
hold off;
err=(s2-s)*100;
pause;
plot([1:maxn],err,'b');
title ('Modulacja DPCM - rnica pomidzy sygnaem zdemodulowanym a oryginalnym [%]');
ylabel ('%');
